Namespace Data
    'Auflistung der Audio-Objekte
    Public Class AudioCollection
        Inherits CollectionBase

        Public Sub New(ByVal Owner As Data.Movie)
            Me.owner = Owner
        End Sub

        Private owner As Data.Movie

        Default Property Item(ByVal Index As Integer) As Data.Audio
            Get
                Return CType(List(Index), Data.Audio)
            End Get
            Set(ByVal Value As Data.Audio)
                List(Index) = Value
            End Set
        End Property

        Public Function Add(ByVal Audio As Data.Audio) As Integer
            Dim result As Integer
            Audio.Movie = Me.owner
            result = List.Add(Audio)
            Return result
        End Function

        Public Function IndexOf(ByVal Audio As Data.Audio) As Integer
            Return List.IndexOf(Audio)
        End Function


        Public Sub Insert(ByVal Index As Integer, ByVal Audio As Data.Audio)
            List.Insert(Index, Audio)
        End Sub


        Public Sub Remove(ByVal Audio As Data.Audio)
            List.Remove(Audio)
        End Sub


        Public Function Contains(ByVal Audio As Data.Audio) As Boolean
            Return List.Contains(Audio)
        End Function


        Public Shadows Sub Clear()
            MyBase.Clear()
        End Sub
    End Class
End Namespace