Public Class Images
    Private Shared m_muxxi As New System.Drawing.Icon(GetType(Main), "Finder.ico")
    Public Shared ReadOnly Property Muxxi() As System.Drawing.Icon
        Get
            Return m_muxxi
        End Get
    End Property

    Private Shared m_exists As New System.Drawing.Bitmap(GetType(Main), "Exists.png")
    Public Shared ReadOnly Property Exists() As Bitmap
        Get
            Return m_exists
        End Get
    End Property

    Private Shared m_notexists As New System.Drawing.Bitmap(GetType(Main), "NotExists.png")
    Public Shared ReadOnly Property NotExists() As Bitmap
        Get
            Return m_notexists
        End Get
    End Property

    Private Shared m_audio As New System.Drawing.Bitmap(GetType(Main), "Audio.png")
    Public Shared ReadOnly Property Audio() As Bitmap
        Get
            Return m_audio
        End Get
    End Property

    Private Shared m_mono As New System.Drawing.Bitmap(GetType(Main), "Mono.png")
    Public Shared ReadOnly Property Mono() As Bitmap
        Get
            Return m_mono
        End Get
    End Property

    Private Shared m_stereo As New System.Drawing.Bitmap(GetType(Main), "Stereo.png")
    Public Shared ReadOnly Property Stereo() As Bitmap
        Get
            Return m_stereo
        End Get
    End Property

    Private Shared m_dualchannel As New System.Drawing.Bitmap(GetType(Main), "DualChannel.png")
    Public Shared ReadOnly Property DualChannel() As Bitmap
        Get
            Return m_dualchannel
        End Get
    End Property

    Private Shared m_ac3 As New System.Drawing.Bitmap(GetType(Main), "AC3.png")
    Public Shared ReadOnly Property AC3() As Bitmap
        Get
            Return m_ac3
        End Get
    End Property

    Private Shared m_video As New System.Drawing.Bitmap(GetType(Main), "Video.png")
    Public Shared ReadOnly Property Video() As Bitmap
        Get
            Return m_video
        End Get
    End Property

    Private Shared m_clock As New System.Drawing.Bitmap(GetType(Main), "Clock.png")
    Public Shared ReadOnly Property Clock() As Bitmap
        Get
            Return m_clock
        End Get
    End Property

    Private Shared m_complete As New System.Drawing.Bitmap(GetType(Main), "Complete.png")
    Public Shared ReadOnly Property Complete() As Bitmap
        Get
            Return m_complete
        End Get
    End Property

    Private Shared m_delall As New System.Drawing.Bitmap(GetType(Main), "DelAll.png")
    Public Shared ReadOnly Property DelAll() As Bitmap
        Get
            Return m_delall
        End Get
    End Property

    Private Shared m_down As New System.Drawing.Bitmap(GetType(Main), "Down.png")
    Public Shared ReadOnly Property Down() As Bitmap
        Get
            Return m_down
        End Get
    End Property

    Private Shared m_dvd As New System.Drawing.Bitmap(GetType(Main), "DVD.png")
    Public Shared ReadOnly Property DVD() As Bitmap
        Get
            Return m_dvd
        End Get
    End Property

    Private Shared m_error As New System.Drawing.Bitmap(GetType(Main), "Error.png")
    Public Shared ReadOnly Property [Error]() As Bitmap
        Get
            Return m_error
        End Get
    End Property

    Private Shared m_folder As New System.Drawing.Bitmap(GetType(Main), "Folder.png")
    Public Shared ReadOnly Property Folder() As Bitmap
        Get
            Return m_folder
        End Get
    End Property

    Private Shared m_info As New System.Drawing.Bitmap(GetType(Main), "Info.png")
    Public Shared ReadOnly Property Info() As Bitmap
        Get
            Return m_info
        End Get
    End Property

    Private Shared m_input As New System.Drawing.Bitmap(GetType(Main), "Input.png")
    Public Shared ReadOnly Property Input() As Bitmap
        Get
            Return m_input
        End Get
    End Property

    Private Shared m_language As New System.Drawing.Bitmap(GetType(Main), "Language.png")
    Public Shared ReadOnly Property Language() As Bitmap
        Get
            Return m_language
        End Get
    End Property

    Private Shared m_minus As New System.Drawing.Bitmap(GetType(Main), "Minus.png")
    Public Shared ReadOnly Property Minus() As Bitmap
        Get
            Return m_minus
        End Get
    End Property

    Private Shared m_mpg As New System.Drawing.Bitmap(GetType(Main), "MPG.png")
    Public Shared ReadOnly Property MPG() As Bitmap
        Get
            Return m_mpg
        End Get
    End Property

    Private Shared m_none As New System.Drawing.Bitmap(GetType(Main), "None.png")
    Public Shared ReadOnly Property None() As Bitmap
        Get
            Return m_none
        End Get
    End Property

    Private Shared m_output As New System.Drawing.Bitmap(GetType(Main), "Output.png")
    Public Shared ReadOnly Property Output() As Bitmap
        Get
            Return m_output
        End Get
    End Property

    Private Shared m_plus As New System.Drawing.Bitmap(GetType(Main), "Plus.png")
    Public Shared ReadOnly Property Plus() As Bitmap
        Get
            Return m_plus
        End Get
    End Property

    Private Shared m_recycle As New System.Drawing.Bitmap(GetType(Main), "Recycle.png")
    Public Shared ReadOnly Property Recycle() As Bitmap
        Get
            Return m_recycle
        End Get
    End Property

    Private Shared m_start As New System.Drawing.Bitmap(GetType(Main), "Start.png")
    Public Shared ReadOnly Property Start() As Bitmap
        Get
            Return m_start
        End Get
    End Property

    Private Shared m_unknown As New System.Drawing.Bitmap(GetType(Main), "Unknown.png")
    Public Shared ReadOnly Property Unknown() As Bitmap
        Get
            Return m_unknown
        End Get
    End Property

    Private Shared m_up As New System.Drawing.Bitmap(GetType(Main), "Up.png")
    Public Shared ReadOnly Property Up() As Bitmap
        Get
            Return m_up
        End Get
    End Property

    Private Shared m_vob As New System.Drawing.Bitmap(GetType(Main), "VOB.png")
    Public Shared ReadOnly Property VOB() As Bitmap
        Get
            Return m_vob
        End Get
    End Property

    Private Shared m_write As New System.Drawing.Bitmap(GetType(Main), "Write.png")
    Public Shared ReadOnly Property Write() As Bitmap
        Get
            Return m_write
        End Get
    End Property

    Private Shared m_writeline As New System.Drawing.Bitmap(GetType(Main), "Writeline.png")
    Public Shared ReadOnly Property Writeline() As Bitmap
        Get
            Return m_writeline
        End Get
    End Property

    Public Shared List As New ImageList

    Public Shared Function Item(ByVal Icon As Images.Icon) As Image
        Return List.Images(Icon)
    End Function

    Public Shared Sub Load()
        'None
        Images.List.Images.Add(New Bitmap(GetType(Main), "None.png"))

        'OutputTypen
        Images.List.Images.Add(New Bitmap(GetType(Main), "MPG.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "VOB.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "DVD.png"))

        'Streamtypen
        Images.List.Images.Add(New Bitmap(GetType(Main), "Audio.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Video.png"))

        'Input, Output und Recycle von Files
        Images.List.Images.Add(New Bitmap(GetType(Main), "Input.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Output.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Recycle.png"))

        'Start und Ende eines Prozesses
        Images.List.Images.Add(New Bitmap(GetType(Main), "Start.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Complete.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Clock.png"))

        'Informationen zum Ablauf und Fehlersymbole
        Images.List.Images.Add(New Bitmap(GetType(Main), "Info.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Write.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Writeline.png"))

        Images.List.Images.Add(New Bitmap(GetType(Main), "Error.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Unknown.png"))

        'Bilder fr diverse Buttons
        Images.List.Images.Add(New Bitmap(GetType(Main), "Folder.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Language.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "DelAll.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Up.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Down.png"))

        Images.List.Images.Add(New Bitmap(GetType(Main), "Plus.png"))
        Images.List.Images.Add(New Bitmap(GetType(Main), "Minus.png"))
    End Sub

    Public Enum Icon
        None

        'OutputTypen
        MPG
        VOB
        DVD

        'Streamtypen
        Audio
        Video

        'Input, Output und Lschen von Files
        Input
        Output
        Recycle

        'Start und Ende eines Prozesses
        Start
        Complete
        Clock

        'Informationen zum Ablauf und Fehlersymbole
        Info
        Write
        WriteLine

        [Error]
        Unknown

        'Bilder fr diverse Buttons
        Folder
        Language
        DeleteAll
        Up
        Down
        Plus
        Minus
    End Enum
End Class


