Imports System
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Text

Namespace Settings
    Public Class INI
        Private Shared FileName As String = String.Format("{0}/{1}.ini", Application.StartupPath, Application.ProductName)

        <DllImport("kernel32")> _
        Private Shared Function WritePrivateProfileString(ByVal section As String, ByVal key As String, ByVal val As String, ByVal filePath As String) As Long
        End Function

        <DllImport("kernel32")> _
        Private Shared Function GetPrivateProfileString(ByVal section As String, ByVal key As String, ByVal def As String, ByVal retVal As StringBuilder, ByVal size As Integer, ByVal filePath As String) As Integer
        End Function

        Public Shared Sub Write(ByVal Section As String, ByVal Key As String, ByVal Value As String)
            WritePrivateProfileString(Section, Key, Value, FileName)
        End Sub

        Public Shared Function Read(ByVal Section As String, ByVal Key As String, ByVal DefValue As String) As String
            Dim temp As StringBuilder = New StringBuilder(255)
            Dim i As Integer = GetPrivateProfileString(Section, Key, DefValue, temp, 255, FileName)
            Return temp.ToString
        End Function
    End Class
End Namespace
