Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents ProjectStructure1 As ProjectStructure
    Friend WithEvents Details As System.Windows.Forms.Panel
    Friend WithEvents MenuView As MenuView
    Friend WithEvents MovieView As MovieView
    Friend WithEvents VideoView As VideoView
    Friend WithEvents AudioView As AudioView
    Friend WithEvents NumericUpDown1 As System.Windows.Forms.NumericUpDown
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.ProjectStructure1 = New Muxxi.ProjectStructure
        Me.Details = New System.Windows.Forms.Panel
        Me.MenuView = New Muxxi.MenuView
        Me.MovieView = New Muxxi.MovieView
        Me.VideoView = New Muxxi.VideoView
        Me.AudioView = New Muxxi.AudioView
        Me.NumericUpDown1 = New System.Windows.Forms.NumericUpDown
        CType(Me.NumericUpDown1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'ProjectStructure1
        '
        Me.ProjectStructure1.ForeColor = System.Drawing.Color.FromArgb(CType(0, Byte), CType(0, Byte), CType(0, Byte))
        Me.ProjectStructure1.Location = New System.Drawing.Point(10, 10)
        Me.ProjectStructure1.Name = "ProjectStructure1"
        Me.ProjectStructure1.ProjectForeColor = System.Drawing.Color.FromArgb(CType(255, Byte), CType(255, Byte), CType(255, Byte))
        Me.ProjectStructure1.SelectedForeColor = System.Drawing.Color.FromArgb(CType(0, Byte), CType(0, Byte), CType(0, Byte))
        Me.ProjectStructure1.SelectedProject = Nothing
        Me.ProjectStructure1.Size = New System.Drawing.Size(504, 305)
        Me.ProjectStructure1.TabIndex = 2
        '
        'Details
        '
        Me.Details.Location = New System.Drawing.Point(520, 16)
        Me.Details.Name = "Details"
        Me.Details.Size = New System.Drawing.Size(264, 296)
        Me.Details.TabIndex = 3
        '
        'MenuView
        '
        Me.MenuView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.MenuView.Location = New System.Drawing.Point(0, 0)
        Me.MenuView.Name = "MenuView"
        Me.MenuView.Size = New System.Drawing.Size(296, 248)
        Me.MenuView.TabIndex = 0
        '
        'MovieView
        '
        Me.MovieView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.MovieView.Location = New System.Drawing.Point(0, 0)
        Me.MovieView.Name = "MovieView"
        Me.MovieView.Size = New System.Drawing.Size(248, 232)
        Me.MovieView.TabIndex = 0
        '
        'VideoView
        '
        Me.VideoView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.VideoView.Location = New System.Drawing.Point(0, 0)
        Me.VideoView.Name = "VideoView"
        Me.VideoView.Size = New System.Drawing.Size(296, 248)
        Me.VideoView.TabIndex = 0
        '
        'AudioView
        '
        Me.AudioView.Dock = System.Windows.Forms.DockStyle.Fill
        Me.AudioView.Location = New System.Drawing.Point(0, 0)
        Me.AudioView.Name = "AudioView"
        Me.AudioView.Size = New System.Drawing.Size(296, 248)
        Me.AudioView.TabIndex = 0
        '
        'NumericUpDown1
        '
        Me.NumericUpDown1.Location = New System.Drawing.Point(520, 320)
        Me.NumericUpDown1.Name = "NumericUpDown1"
        Me.NumericUpDown1.Size = New System.Drawing.Size(48, 20)
        Me.NumericUpDown1.TabIndex = 4
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(792, 466)
        Me.Controls.Add(Me.NumericUpDown1)
        Me.Controls.Add(Me.Details)
        Me.Controls.Add(Me.ProjectStructure1)
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.NumericUpDown1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub ProjectStructure1_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ProjectStructure1.SelectionChanged
        If TypeOf ProjectStructure1.SelectedItem Is Data.Menu Then
            MenuView.Menu = DirectCast(ProjectStructure1.SelectedItem, Data.Menu)
            ShowDetails(MenuView)

        ElseIf TypeOf ProjectStructure1.SelectedItem Is Data.Movie Then
            MovieView.Movie = DirectCast(ProjectStructure1.SelectedItem, Data.Movie)
            ShowDetails(MovieView)

        ElseIf TypeOf ProjectStructure1.SelectedItem Is Data.Video Then
            MovieView.Movie = DirectCast(ProjectStructure1.SelectedItem, Data.Video).Movie
            ShowDetails(MovieView)

        ElseIf TypeOf ProjectStructure1.SelectedItem Is Data.Audio Then
            MovieView.Movie = DirectCast(ProjectStructure1.SelectedItem, Data.Audio).Movie
            ShowDetails(MovieView)
        End If
    End Sub

    Private Sub ShowDetails(ByVal Control As Control)
        If Not Me.Details.Contains(Control) Then
            Me.SuspendLayout()
            Me.Details.Controls.Clear()
            Me.Details.Controls.Add(Control)
            Me.ResumeLayout()
        End If
    End Sub

    Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged
        Me.ProjectStructure1.showprojects = NumericUpDown1.Value
    End Sub
End Class
