Imports System.IO

Namespace UI
    Public Class LogDialog
        Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

        Public Sub New()
            MyBase.New()

            ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
            InitializeComponent()

            ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
            'Da die LogList nicht im VS-Designer angezeigt werden kann,
            'wird aus kompatibilitts Grnden das Control erst im Load
            'Ereignis initialisiert
            Me.LogList = New UI.LogList
            Me.LogList.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) Or System.Windows.Forms.AnchorStyles.Left) Or System.Windows.Forms.AnchorStyles.Right)
            Me.LogList.AutoScroll = True
            Me.LogList.BackColor = System.Drawing.Color.White
            Me.LogList.Location = New System.Drawing.Point(8, 8)
            Me.LogList.Name = "LogList"
            Me.LogList.Size = New System.Drawing.Size(456, 376)
            Me.LogList.TabIndex = 1
            Me.Controls.Add(Me.LogList)
            Me.Icon = Images.Muxxi
            Me.TaskIcon.Icon = Images.Muxxi
        End Sub

        ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        ' Fr Windows Form-Designer erforderlich
        Private components As System.ComponentModel.IContainer

        'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
        'Sie kann mit dem Windows Form-Designer modifiziert werden.
        'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
        Friend WithEvents btnOk As System.Windows.Forms.Button
        Friend WithEvents btnAbort As System.Windows.Forms.Button
        Friend WithEvents cbxSaveAndClose As System.Windows.Forms.CheckBox
        Friend WithEvents btnMinimize As System.Windows.Forms.Button
        Friend WithEvents TaskIcon As System.Windows.Forms.NotifyIcon
        Friend WithEvents TaskMenu As System.Windows.Forms.ContextMenu
        Friend WithEvents mniShowLog As System.Windows.Forms.MenuItem
        Friend WithEvents mniAbort As System.Windows.Forms.MenuItem
        Private WithEvents PctProgress As System.Windows.Forms.Label
        Private WithEvents Progress As System.Windows.Forms.ProgressBar
        Friend WithEvents btnPause As System.Windows.Forms.Button
        Friend WithEvents mniPause As System.Windows.Forms.MenuItem
        Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.btnOk = New System.Windows.Forms.Button
            Me.btnAbort = New System.Windows.Forms.Button
            Me.PctProgress = New System.Windows.Forms.Label
            Me.cbxSaveAndClose = New System.Windows.Forms.CheckBox
            Me.btnMinimize = New System.Windows.Forms.Button
            Me.Progress = New System.Windows.Forms.ProgressBar
            Me.TaskIcon = New System.Windows.Forms.NotifyIcon(Me.components)
            Me.TaskMenu = New System.Windows.Forms.ContextMenu
            Me.mniShowLog = New System.Windows.Forms.MenuItem
            Me.MenuItem2 = New System.Windows.Forms.MenuItem
            Me.mniPause = New System.Windows.Forms.MenuItem
            Me.mniAbort = New System.Windows.Forms.MenuItem
            Me.btnPause = New System.Windows.Forms.Button
            Me.SuspendLayout()
            '
            'btnOk
            '
            Me.btnOk.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnOk.Enabled = False
            Me.btnOk.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnOk.Location = New System.Drawing.Point(8, 464)
            Me.btnOk.Name = "btnOk"
            Me.btnOk.TabIndex = 0
            Me.btnOk.Text = "OK"
            '
            'btnAbort
            '
            Me.btnAbort.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnAbort.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnAbort.Location = New System.Drawing.Point(88, 464)
            Me.btnAbort.Name = "btnAbort"
            Me.btnAbort.TabIndex = 3
            Me.btnAbort.Text = "Abbrechen"
            '
            'PctProgress
            '
            Me.PctProgress.Location = New System.Drawing.Point(188, 424)
            Me.PctProgress.Name = "PctProgress"
            Me.PctProgress.Size = New System.Drawing.Size(99, 24)
            Me.PctProgress.TabIndex = 5
            Me.PctProgress.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
            '
            'cbxSaveAndClose
            '
            Me.cbxSaveAndClose.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.cbxSaveAndClose.Location = New System.Drawing.Point(320, 424)
            Me.cbxSaveAndClose.Name = "cbxSaveAndClose"
            Me.cbxSaveAndClose.Size = New System.Drawing.Size(152, 24)
            Me.cbxSaveAndClose.TabIndex = 6
            Me.cbxSaveAndClose.Text = "Speichern und schlieen"
            '
            'btnMinimize
            '
            Me.btnMinimize.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnMinimize.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnMinimize.Location = New System.Drawing.Point(390, 464)
            Me.btnMinimize.Name = "btnMinimize"
            Me.btnMinimize.TabIndex = 7
            Me.btnMinimize.Text = "Minimieren"
            '
            'Progress
            '
            Me.Progress.Location = New System.Drawing.Point(8, 400)
            Me.Progress.Name = "Progress"
            Me.Progress.Size = New System.Drawing.Size(456, 23)
            Me.Progress.Step = 1
            Me.Progress.TabIndex = 4
            '
            'TaskIcon
            '
            Me.TaskIcon.ContextMenu = Me.TaskMenu
            Me.TaskIcon.Text = "Muxxi"
            '
            'TaskMenu
            '
            Me.TaskMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mniShowLog, Me.MenuItem2, Me.mniPause, Me.mniAbort})
            '
            'mniShowLog
            '
            Me.mniShowLog.Index = 0
            Me.mniShowLog.Text = "LOG anzeigen"
            '
            'MenuItem2
            '
            Me.MenuItem2.Index = 1
            Me.MenuItem2.Text = "-"
            '
            'mniPause
            '
            Me.mniPause.Index = 2
            Me.mniPause.Text = "Pause"
            '
            'mniAbort
            '
            Me.mniAbort.Index = 3
            Me.mniAbort.Text = "Abbrechen"
            '
            'btnPause
            '
            Me.btnPause.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.btnPause.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnPause.Location = New System.Drawing.Point(168, 464)
            Me.btnPause.Name = "btnPause"
            Me.btnPause.TabIndex = 8
            Me.btnPause.Text = "Pause"
            '
            'LogDialog
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(474, 496)
            Me.ControlBox = False
            Me.Controls.Add(Me.btnPause)
            Me.Controls.Add(Me.btnMinimize)
            Me.Controls.Add(Me.cbxSaveAndClose)
            Me.Controls.Add(Me.PctProgress)
            Me.Controls.Add(Me.Progress)
            Me.Controls.Add(Me.btnAbort)
            Me.Controls.Add(Me.btnOk)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
            Me.MinimizeBox = False
            Me.Name = "LogDialog"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
            Me.Text = "Muxxi LOG"
            Me.ResumeLayout(False)

        End Sub

#End Region

        Public LogList As UI.LogList
        Public Status As ProcessStatusEnum = ProcessStatusEnum.Ok

        Private Sub LogDialog_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Me.MultiplexProject()
        End Sub

        Public Property SaveAndClose()
            Get
                Return Me.cbxSaveAndClose.Checked
            End Get
            Set(ByVal Value)
                Me.cbxSaveAndClose.Checked = Value
            End Set
        End Property

        Private _progressmax As Integer

        Public Property ProgressMax() As Integer
            Get
                Return Me._progressmax
            End Get
            Set(ByVal Value As Integer)
                Me.Progress.Maximum = Value
                Me._progressmax = Value
            End Set
        End Property

        Public WriteOnly Property ProgressValue() As Integer
            Set(ByVal Value As Integer)
                If Value > ProgressMax Then Value = ProgressMax

                Me.Progress.Value = Value

                If Value = 0 Then
                    Me.PctProgress.Text = String.Empty
                Else
                    Dim Percent As Int16 = (Value / ProgressMax) * 100
                    Me.PctProgress.Text = String.Format("{0} %", Percent)
                End If
            End Set
        End Property

        Public Sub MultiplexProject()
            Dim Projects As ArrayList
            Dim Project As Data.Project

            If Settings.Automatical.Modus Then
                Me.HideWindow()
            Else
                Me.ShowWindow()
            End If

            Application.DoEvents()

            Do
                'Sollte das BatchFile aus irgendeinem Grund
                'nicht exisiteren, so wird die Verarbeitung
                'umgehend abgebrochen
                If Not File.Exists(Settings.Programm.XMLBatchFile) Then
                    Exit Do
                End If

                Projects = OUTPUT.XMLBatchFile.Load(Settings.Programm.XMLBatchFile)
                If Projects.Count = 0 Then
                    Exit Do
                Else
                    Project = CType(Projects(0), Data.Project)
                    Projects.Remove(Project)
                    OUTPUT.XMLBatchFile.Save(Projects, Settings.Programm.XMLBatchFile)

                    Select Case Projects.Count
                        Case 0
                            Me.TaskIcon.Text = "Muxxi - Keine weiteren Projekte"
                        Case 1
                            Me.TaskIcon.Text = "Muxxi - 1 Projekt offen"
                        Case Else
                            Me.TaskIcon.Text = String.Format("Muxxi - {0} Projekte offen", Projects.Count)
                    End Select

                    OUTPUT.LOG.LogDialog.Clear()

                    Application.DoEvents()
                    Project.Muxx()

                    Select Case Me.Status
                        Case ProcessStatusEnum.Abort
                            OUTPUT.LOG.WriteLine(String.Format("Verarbeitung von Projekt '{0}' durch Benutzer abgebrochen!", Project.Text), Images.Icon.Error)

                            'Wenn die Verarbeitung nicht ber Commandozeilen Parameter gestartet wurde, dann wird
                            'der aktuelle Job wieder in die ProjektListe mit aufgenommen, um anschlieend im
                            'StreamSelection-Dialog bearbeitet werden zu knnnen
                            If Not Settings.Automatical.Modus Then OUTPUT.XMLBatchFile.AddProject(Project, Settings.Programm.XMLBatchFile, OUTPUT.XMLBatchFile.Position.First)
                        Case ProcessStatusEnum.Error
                            OUTPUT.LOG.WriteLine(String.Format("Verarbeitung von Projekt '{0}' auf Grund eines Fehlers abgebrochen!", Project.Text), Images.Icon.Error)

                            'Wenn die Verarbeitung nicht ber Commandozeilen Parameter gestartet wurde, dann wird
                            'der aktuelle Job wieder in die ProjektListe mit aufgenommen, um anschlieend im
                            'StreamSelection-Dialog bearbeitet werden zu knnnen
                            If Not Settings.Automatical.Modus Then OUTPUT.XMLBatchFile.AddProject(Project, Settings.Programm.XMLBatchFile, OUTPUT.XMLBatchFile.Position.First)
                        Case ProcessStatusEnum.Pause
                            OUTPUT.LOG.WriteLine(String.Format("Projekt '{0}' abgeschlossen!", Project.Text), Images.Icon.Complete)
                            OUTPUT.LOG.WriteLine(String.Format("Bentigte Zeit: {0}", Functions.EndTime(Project.StartTime)), Images.Icon.None)

                            Projects = OUTPUT.XMLBatchFile.Load(Settings.Programm.XMLBatchFile)
                            If Projects.Count = 0 Then
                                OUTPUT.LOG.LogDialog.Status = ProcessStatusEnum.Ok
                                Exit Do
                            End If

                            OUTPUT.LOG.WriteLine("Verarbeitung pausiert!", Images.Icon.Info)
                        Case ProcessStatusEnum.Ok
                            OUTPUT.LOG.WriteLine(String.Format("Projekt '{0}' abgeschlossen!", Project.Text), Images.Icon.Complete)
                            OUTPUT.LOG.WriteLine(String.Format("Bentigte Zeit: {0}", Functions.EndTime(Project.StartTime)), Images.Icon.None)
                    End Select

                    OUTPUT.ProjectProcessing.Out.Close()
                    OUTPUT.LOG.Out.Close()
                    Beep()

                    If Not Me.Status = ProcessStatusEnum.Ok Then
                        OUTPUT.LOG.LogDialog.Complete()
                        Exit Sub
                    End If
                End If
            Loop

            System.IO.File.Delete(Settings.Programm.XMLBatchFile)
            OUTPUT.LOG.LogDialog.Complete()
        End Sub

        Public Sub Clear()
            Me.LogList.Items.Clear()
            Me.LogList.Controls.Clear()

            Me.btnOk.Enabled = False
            Me.btnAbort.Enabled = True
            Me.mniAbort.Enabled = True

            Me.btnPause.Enabled = True
            Me.mniPause.Enabled = True

            Me.Status = ProcessStatusEnum.Ok
        End Sub

        Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
            Me.Close()
        End Sub

        'ber WriteLine kann der LogList eine neue Zeile hinzugefgt werden
        Public Sub Write(ByVal Text As String, ByVal Icon As Images.Icon)
            Dim newItem As New UI.LogListItem
            Dim x As Int32
            Dim y As Int32

            newItem.Text = Text
            newItem.Icon = Icon

            'Wenn kein Bild angezeigt werden soll, dann wird
            'die Zeit auf String.Empty gestellt
            Select Case Icon
                Case Images.Icon.None
                    newItem.NoTime()
            End Select

            Select Case LogList.Controls.Count
                Case 0
                    newItem.Location = New System.Drawing.Point(0, 0)
                Case Else
                    newItem.Location = New System.Drawing.Point(0, (Me.LogList.Controls.Count * 15) + Me.LogList.Controls(0).Location.Y)
            End Select

            Me.LogList.Add(newItem)

            Me.LogList.Invalidate()

            OUTPUT.LOG.Out.WriteLine(newItem.ToString)

            'Um die Anzeige der LOG-Zeilen sicher zustellen
            'wird AutoscrollPostion nicht berwacht, sobald
            'der LOG-Dialog ausgeblendet wurde.
            If Not Me.Visible Then Exit Sub

            'Es wird die Position der neuen LOG-Zeile errechnet
            'und gegebenenfalls dort hin gescrollt
            If (newItem.Location.Y + newItem.Height) > Me.LogList.Height Then
                Dim AutoScrollY As Integer = newItem.Location.Y + newItem.Height
                AutoScrollY += Math.Abs(Me.LogList.AutoScrollPosition.Y)
                AutoScrollY -= Me.LogList.Height
                Me.LogList.AutoScrollPosition = New Drawing.Point(0, AutoScrollY)
            End If
        End Sub

        Public Sub EmptyLine()
            Me.Write(String.Empty, Images.Icon.None)
        End Sub

        Private Sub btnAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbort.Click, mniAbort.Click
            Me.EmptyLine()
            Me.Write("Einen Moment bitte, offene Aktionen werden beendet...", Images.Icon.Error)
            Me.Status = ProcessStatusEnum.Abort
        End Sub

        Public Sub Complete()
            Select Case Me.Status
                Case ProcessStatusEnum.Pause
                    Me.btnOk.Enabled = True
                    Me.btnAbort.Enabled = False
                    Me.mniAbort.Enabled = False

                    Me.ProgressValue = 0
                    Me.Status = ProcessStatusEnum.Waiting
                    Me.ShowWindow()

                    Refresh()
                Case Else
                    Select Case SaveAndClose
                        Case True
                            Me.Close()
                        Case False
                            Me.btnOk.Enabled = True
                            Me.btnAbort.Enabled = False
                            Me.mniAbort.Enabled = False

                            Me.btnPause.Enabled = False
                            Me.mniPause.Enabled = False
                            Me.ProgressValue = 0
                            Me.ShowWindow()

                            Refresh()
                    End Select
            End Select

        End Sub

        Private Sub btnMinimize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMinimize.Click
            Me.HideWindow()
        End Sub

        Private Sub LogDialog_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
            Me.TaskIcon.Dispose()
        End Sub

        Private Sub HideWindow()
            Me.Hide()
            Me.TaskIcon.Visible = True
        End Sub

        Private Sub ShowWindow()
            Me.TaskIcon.Visible = False
            Me.Show()
        End Sub

        Private Sub mniShowLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniShowLog.Click
            Me.ShowWindow()
        End Sub

        Private Sub TaskIcon_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TaskIcon.MouseDown
            Select Case e.Button
                Case MouseButtons.Left
                    Me.ShowWindow()
            End Select
        End Sub

        Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click, mniPause.Click
            Select Case Me.Status
                Case ProcessStatusEnum.Ok
                    Me.Status = ProcessStatusEnum.Pause
                    Me.btnPause.Text = "Weiter"
                    Me.mniPause.Text = "Weiter"

                Case ProcessStatusEnum.Pause
                    Me.Status = ProcessStatusEnum.Ok
                    Me.btnPause.Text = "Pause"
                    Me.mniPause.Text = "Pause"

                Case ProcessStatusEnum.Waiting
                    Me.btnPause.Text = "Pause"
                    Me.mniPause.Text = "Pause"
                    Me.MultiplexProject()
            End Select

        End Sub
    End Class
End Namespace

Public Enum ProcessStatusEnum
    Abort
    [Error]
    Ok
    Pause
    Waiting
End Enum

