Imports System.IO

Namespace UI
    Public Class ProjectDialog
        Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

        Public Sub New()
            MyBase.New()

            ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
            InitializeComponent()

            ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
            Me.Icon = Images.Muxxi
            Me.Text = Settings.Programm.Name
            Me.StreamTree.ImageList = Images.List
        End Sub

        ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        ' Fr Windows Form-Designer erforderlich
        Private components As System.ComponentModel.IContainer

        'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
        'Sie kann mit dem Windows Form-Designer modifiziert werden.
        'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
        Friend WithEvents MainMenu As System.Windows.Forms.MainMenu
        Friend WithEvents colName As System.Windows.Forms.ColumnHeader
        Friend WithEvents colType As System.Windows.Forms.ColumnHeader
        Friend WithEvents colStreams As System.Windows.Forms.ColumnHeader
        Friend WithEvents colOutput As System.Windows.Forms.ColumnHeader
        Friend WithEvents grpStreams As System.Windows.Forms.GroupBox
        Friend WithEvents lblProjectName As System.Windows.Forms.Label
        Friend WithEvents txtProjectName As System.Windows.Forms.TextBox
        Friend WithEvents txtOutput As System.Windows.Forms.TextBox
        Friend WithEvents CenterFrame As System.Windows.Forms.Panel
        Friend WithEvents cbxKeepDVDStructure As System.Windows.Forms.CheckBox
        Friend WithEvents grpOutputType As System.Windows.Forms.GroupBox
        Friend WithEvents optES As System.Windows.Forms.RadioButton
        Friend WithEvents optMPG As System.Windows.Forms.RadioButton
        Friend WithEvents optVOB As System.Windows.Forms.RadioButton
        Friend WithEvents optDVD As System.Windows.Forms.RadioButton
        Friend WithEvents StreamTree As UI.StreamTree
        Friend WithEvents start As System.Windows.Forms.Button
        Friend WithEvents btnActualizeName As UI.ImageButton
        Friend WithEvents QuickInfo As System.Windows.Forms.ToolTip
        Friend WithEvents grp As System.Windows.Forms.GroupBox
        Friend WithEvents grpAutoCut As System.Windows.Forms.GroupBox
        Friend WithEvents Label5 As System.Windows.Forms.Label
        Friend WithEvents updAsplit As System.Windows.Forms.NumericUpDown
        Friend WithEvents Label6 As System.Windows.Forms.Label
        Friend WithEvents lblVsplit2 As System.Windows.Forms.Label
        Friend WithEvents updVsplit As System.Windows.Forms.NumericUpDown
        Friend WithEvents lblVsplit As System.Windows.Forms.Label
        Friend WithEvents cbxGenerateIDD As System.Windows.Forms.CheckBox
        Friend WithEvents txtFilmLength As System.Windows.Forms.TextBox
        Friend WithEvents Label2 As System.Windows.Forms.Label
        Friend WithEvents txtChapterLength As System.Windows.Forms.TextBox
        Friend WithEvents Label3 As System.Windows.Forms.Label
        Friend WithEvents btnNewStream As UI.ImageButton
        Friend WithEvents btnEditVideo As UI.ImageButton
        Friend WithEvents btnAddAudio As UI.ImageButton
        Friend WithEvents btnDelElement As UI.ImageButton
        Friend WithEvents btnOutputFolder As UI.ImageButton
        Friend WithEvents mniProjects As System.Windows.Forms.MenuItem
        Friend WithEvents mniStandardSettings As System.Windows.Forms.MenuItem
        Friend WithEvents mniOpenProject As System.Windows.Forms.MenuItem
        Friend WithEvents mniSaveProject As System.Windows.Forms.MenuItem
        Friend WithEvents mniSaveAll As System.Windows.Forms.MenuItem
        Friend WithEvents mniSaveCurrent As System.Windows.Forms.MenuItem
        Friend WithEvents btnOpenChapterlist As UI.ImageButton
        Friend WithEvents HelpBar As System.Windows.Forms.StatusBar
        Friend WithEvents BottomFrame As System.Windows.Forms.Panel
        Friend WithEvents btnDelProject As UI.ImageButton
        Friend WithEvents btnNewProject As UI.ImageButton
        Friend WithEvents ProjectList As UI.ProjectList
        Friend WithEvents btnUp As UI.ImageButton
        Friend WithEvents btnDown As UI.ImageButton
        Friend WithEvents cbxCreateDVDMenu As System.Windows.Forms.CheckBox
        Friend WithEvents ImageButton1 As Muxxi.UI.ImageButton
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.MainMenu = New System.Windows.Forms.MainMenu
            Me.mniProjects = New System.Windows.Forms.MenuItem
            Me.mniOpenProject = New System.Windows.Forms.MenuItem
            Me.mniSaveProject = New System.Windows.Forms.MenuItem
            Me.mniSaveAll = New System.Windows.Forms.MenuItem
            Me.mniSaveCurrent = New System.Windows.Forms.MenuItem
            Me.mniStandardSettings = New System.Windows.Forms.MenuItem
            Me.colName = New System.Windows.Forms.ColumnHeader
            Me.colType = New System.Windows.Forms.ColumnHeader
            Me.colStreams = New System.Windows.Forms.ColumnHeader
            Me.colOutput = New System.Windows.Forms.ColumnHeader
            Me.grpStreams = New System.Windows.Forms.GroupBox
            Me.btnDown = New Muxxi.UI.ImageButton
            Me.btnUp = New Muxxi.UI.ImageButton
            Me.btnDelElement = New Muxxi.UI.ImageButton
            Me.btnAddAudio = New Muxxi.UI.ImageButton
            Me.btnEditVideo = New Muxxi.UI.ImageButton
            Me.btnNewStream = New Muxxi.UI.ImageButton
            Me.StreamTree = New Muxxi.UI.StreamTree
            Me.lblProjectName = New System.Windows.Forms.Label
            Me.txtProjectName = New System.Windows.Forms.TextBox
            Me.txtOutput = New System.Windows.Forms.TextBox
            Me.CenterFrame = New System.Windows.Forms.Panel
            Me.btnOutputFolder = New Muxxi.UI.ImageButton
            Me.btnActualizeName = New Muxxi.UI.ImageButton
            Me.start = New System.Windows.Forms.Button
            Me.grp = New System.Windows.Forms.GroupBox
            Me.grpAutoCut = New System.Windows.Forms.GroupBox
            Me.Label5 = New System.Windows.Forms.Label
            Me.updAsplit = New System.Windows.Forms.NumericUpDown
            Me.Label6 = New System.Windows.Forms.Label
            Me.lblVsplit2 = New System.Windows.Forms.Label
            Me.updVsplit = New System.Windows.Forms.NumericUpDown
            Me.lblVsplit = New System.Windows.Forms.Label
            Me.cbxGenerateIDD = New System.Windows.Forms.CheckBox
            Me.txtFilmLength = New System.Windows.Forms.TextBox
            Me.Label2 = New System.Windows.Forms.Label
            Me.txtChapterLength = New System.Windows.Forms.TextBox
            Me.Label3 = New System.Windows.Forms.Label
            Me.cbxKeepDVDStructure = New System.Windows.Forms.CheckBox
            Me.grpOutputType = New System.Windows.Forms.GroupBox
            Me.optES = New System.Windows.Forms.RadioButton
            Me.optMPG = New System.Windows.Forms.RadioButton
            Me.optVOB = New System.Windows.Forms.RadioButton
            Me.optDVD = New System.Windows.Forms.RadioButton
            Me.btnOpenChapterlist = New Muxxi.UI.ImageButton
            Me.cbxCreateDVDMenu = New System.Windows.Forms.CheckBox
            Me.QuickInfo = New System.Windows.Forms.ToolTip(Me.components)
            Me.btnDelProject = New Muxxi.UI.ImageButton
            Me.btnNewProject = New Muxxi.UI.ImageButton
            Me.HelpBar = New System.Windows.Forms.StatusBar
            Me.BottomFrame = New System.Windows.Forms.Panel
            Me.ProjectList = New Muxxi.UI.ProjectList
            Me.ImageButton1 = New Muxxi.UI.ImageButton
            Me.grpStreams.SuspendLayout()
            Me.CenterFrame.SuspendLayout()
            Me.grp.SuspendLayout()
            Me.grpAutoCut.SuspendLayout()
            CType(Me.updAsplit, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.updVsplit, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.grpOutputType.SuspendLayout()
            Me.BottomFrame.SuspendLayout()
            Me.SuspendLayout()
            '
            'MainMenu
            '
            Me.MainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mniProjects, Me.mniStandardSettings})
            '
            'mniProjects
            '
            Me.mniProjects.Index = 0
            Me.mniProjects.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mniOpenProject, Me.mniSaveProject})
            Me.mniProjects.Text = "Projekte"
            '
            'mniOpenProject
            '
            Me.mniOpenProject.Index = 0
            Me.mniOpenProject.Text = "ffnen"
            '
            'mniSaveProject
            '
            Me.mniSaveProject.Index = 1
            Me.mniSaveProject.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mniSaveAll, Me.mniSaveCurrent})
            Me.mniSaveProject.Text = "Speichern"
            '
            'mniSaveAll
            '
            Me.mniSaveAll.Index = 0
            Me.mniSaveAll.Text = "Alle"
            '
            'mniSaveCurrent
            '
            Me.mniSaveCurrent.Index = 1
            Me.mniSaveCurrent.Text = "Markiert"
            '
            'mniStandardSettings
            '
            Me.mniStandardSettings.Index = 1
            Me.mniStandardSettings.Text = "Einstellungen"
            '
            'colName
            '
            Me.colName.Text = "Project Name"
            Me.colName.Width = 200
            '
            'colType
            '
            Me.colType.Text = "Type"
            Me.colType.Width = 45
            '
            'colStreams
            '
            Me.colStreams.Text = "Anzahl"
            Me.colStreams.Width = 50
            '
            'colOutput
            '
            Me.colOutput.Text = "Zielverzeichnis"
            Me.colOutput.Width = 475
            '
            'grpStreams
            '
            Me.grpStreams.Controls.Add(Me.btnDown)
            Me.grpStreams.Controls.Add(Me.btnUp)
            Me.grpStreams.Controls.Add(Me.btnDelElement)
            Me.grpStreams.Controls.Add(Me.btnAddAudio)
            Me.grpStreams.Controls.Add(Me.btnEditVideo)
            Me.grpStreams.Controls.Add(Me.btnNewStream)
            Me.grpStreams.Controls.Add(Me.StreamTree)
            Me.grpStreams.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.grpStreams.Location = New System.Drawing.Point(8, 56)
            Me.grpStreams.Name = "grpStreams"
            Me.grpStreams.Size = New System.Drawing.Size(544, 224)
            Me.grpStreams.TabIndex = 31
            Me.grpStreams.TabStop = False
            Me.grpStreams.Text = "Streams"
            '
            'btnDown
            '
            Me.btnDown.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnDown.Location = New System.Drawing.Point(5, 136)
            Me.btnDown.Name = "btnDown"
            Me.btnDown.Size = New System.Drawing.Size(24, 24)
            Me.btnDown.TabIndex = 48
            Me.btnDown.Tag = "AddAudio"
            Me.btnDown.ThemedImage = Nothing
            Me.btnDown.SetImage(Images.Down)
            Me.QuickInfo.SetToolTip(Me.btnDown, "In der Auflistung nach unten")
            '
            'btnUp
            '
            Me.btnUp.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnUp.Location = New System.Drawing.Point(5, 112)
            Me.btnUp.Name = "btnUp"
            Me.btnUp.Size = New System.Drawing.Size(24, 24)
            Me.btnUp.TabIndex = 47
            Me.btnUp.Tag = "EditVideo"
            Me.btnUp.ThemedImage = Nothing
            Me.btnUp.SetImage(Images.Up)
            Me.QuickInfo.SetToolTip(Me.btnUp, "In der Auflistung nach oben")
            '
            'btnDelElement
            '
            Me.btnDelElement.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnDelElement.Location = New System.Drawing.Point(5, 192)
            Me.btnDelElement.Name = "btnDelElement"
            Me.btnDelElement.Size = New System.Drawing.Size(24, 24)
            Me.btnDelElement.TabIndex = 46
            Me.btnDelElement.Tag = "DelElement"
            Me.btnDelElement.ThemedImage = Nothing
            Me.btnDelElement.SetImage(Images.Error)
            Me.QuickInfo.SetToolTip(Me.btnDelElement, "Markiertes Element lschen")
            '
            'btnAddAudio
            '
            Me.btnAddAudio.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnAddAudio.Location = New System.Drawing.Point(5, 64)
            Me.btnAddAudio.Name = "btnAddAudio"
            Me.btnAddAudio.Size = New System.Drawing.Size(24, 24)
            Me.btnAddAudio.TabIndex = 45
            Me.btnAddAudio.Tag = "AddAudio"
            Me.btnAddAudio.ThemedImage = Nothing
            Me.btnAddAudio.SetImage(Images.Audio)
            Me.QuickInfo.SetToolTip(Me.btnAddAudio, "Audio-Datei hinzufgen")
            '
            'btnEditVideo
            '
            Me.btnEditVideo.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnEditVideo.Location = New System.Drawing.Point(5, 40)
            Me.btnEditVideo.Name = "btnEditVideo"
            Me.btnEditVideo.Size = New System.Drawing.Size(24, 24)
            Me.btnEditVideo.TabIndex = 44
            Me.btnEditVideo.Tag = "EditVideo"
            Me.btnEditVideo.ThemedImage = Nothing
            Me.btnEditVideo.SetImage(Images.Video)
            Me.QuickInfo.SetToolTip(Me.btnEditVideo, "Video-Datei whlen")
            '
            'btnNewStream
            '
            Me.btnNewStream.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnNewStream.GenerateDisabledImage = True
            Me.btnNewStream.Location = New System.Drawing.Point(5, 16)
            Me.btnNewStream.Name = "btnNewStream"
            Me.btnNewStream.Size = New System.Drawing.Size(24, 24)
            Me.btnNewStream.TabIndex = 43
            Me.btnNewStream.Tag = "NewStream"
            Me.btnNewStream.ThemedImage = Nothing
            Me.btnNewStream.SetImage(Images.Input)
            Me.QuickInfo.SetToolTip(Me.btnNewStream, "Neuen Stream hinzufgen")
            '
            'StreamTree
            '
            Me.StreamTree.AllowDrop = True
            Me.StreamTree.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            Me.StreamTree.FullRowSelect = True
            Me.StreamTree.HideSelection = False
            Me.StreamTree.ImageIndex = -1
            Me.StreamTree.Location = New System.Drawing.Point(32, 16)
            Me.StreamTree.Name = "StreamTree"
            Me.StreamTree.Project = Nothing
            Me.StreamTree.SelectedImageIndex = -1
            Me.StreamTree.ShowLines = False
            Me.StreamTree.Size = New System.Drawing.Size(504, 200)
            Me.StreamTree.TabIndex = 0
            '
            'lblProjectName
            '
            Me.lblProjectName.Location = New System.Drawing.Point(8, 8)
            Me.lblProjectName.Name = "lblProjectName"
            Me.lblProjectName.Size = New System.Drawing.Size(112, 16)
            Me.lblProjectName.TabIndex = 30
            Me.lblProjectName.Text = "Projekt Bezeichnung"
            '
            'txtProjectName
            '
            Me.txtProjectName.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.txtProjectName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            Me.txtProjectName.Location = New System.Drawing.Point(8, 24)
            Me.txtProjectName.Name = "txtProjectName"
            Me.txtProjectName.Size = New System.Drawing.Size(512, 20)
            Me.txtProjectName.TabIndex = 29
            Me.txtProjectName.Text = ""
            '
            'txtOutput
            '
            Me.txtOutput.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.txtOutput.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            Me.txtOutput.Location = New System.Drawing.Point(8, 288)
            Me.txtOutput.Name = "txtOutput"
            Me.txtOutput.Size = New System.Drawing.Size(640, 20)
            Me.txtOutput.TabIndex = 22
            Me.txtOutput.Text = ""
            '
            'CenterFrame
            '
            Me.CenterFrame.BackColor = System.Drawing.SystemColors.Control
            Me.CenterFrame.Controls.Add(Me.ImageButton1)
            Me.CenterFrame.Controls.Add(Me.btnOutputFolder)
            Me.CenterFrame.Controls.Add(Me.btnActualizeName)
            Me.CenterFrame.Controls.Add(Me.start)
            Me.CenterFrame.Controls.Add(Me.grp)
            Me.CenterFrame.Controls.Add(Me.grpStreams)
            Me.CenterFrame.Controls.Add(Me.lblProjectName)
            Me.CenterFrame.Controls.Add(Me.txtProjectName)
            Me.CenterFrame.Controls.Add(Me.txtOutput)
            Me.CenterFrame.Dock = System.Windows.Forms.DockStyle.Top
            Me.CenterFrame.Location = New System.Drawing.Point(0, 0)
            Me.CenterFrame.Name = "CenterFrame"
            Me.CenterFrame.Size = New System.Drawing.Size(794, 320)
            Me.CenterFrame.TabIndex = 5
            '
            'btnOutputFolder
            '
            Me.btnOutputFolder.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnOutputFolder.Location = New System.Drawing.Point(656, 286)
            Me.btnOutputFolder.Name = "btnOutputFolder"
            Me.btnOutputFolder.Size = New System.Drawing.Size(24, 24)
            Me.btnOutputFolder.TabIndex = 47
            Me.btnOutputFolder.Tag = ""
            Me.btnOutputFolder.ThemedImage = Nothing
            Me.btnOutputFolder.SetImage(Images.Folder)
            Me.QuickInfo.SetToolTip(Me.btnOutputFolder, "Output Verzeichnis whlen")
            '
            'btnActualizeName
            '
            Me.btnActualizeName.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnActualizeName.Location = New System.Drawing.Point(528, 22)
            Me.btnActualizeName.Name = "btnActualizeName"
            Me.btnActualizeName.Size = New System.Drawing.Size(24, 24)
            Me.btnActualizeName.TabIndex = 42
            Me.btnActualizeName.ThemedImage = Nothing
            Me.btnActualizeName.SetImage(Images.Unknown)
            Me.QuickInfo.SetToolTip(Me.btnActualizeName, "Streamname als Projektname bernehmen")
            '
            'start
            '
            Me.start.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.start.Location = New System.Drawing.Point(735, 288)
            Me.start.Name = "start"
            Me.start.Size = New System.Drawing.Size(56, 24)
            Me.start.TabIndex = 41
            Me.start.Text = "Start"
            '
            'grp
            '
            Me.grp.Controls.Add(Me.grpAutoCut)
            Me.grp.Controls.Add(Me.cbxGenerateIDD)
            Me.grp.Controls.Add(Me.txtFilmLength)
            Me.grp.Controls.Add(Me.Label2)
            Me.grp.Controls.Add(Me.txtChapterLength)
            Me.grp.Controls.Add(Me.Label3)
            Me.grp.Controls.Add(Me.cbxKeepDVDStructure)
            Me.grp.Controls.Add(Me.grpOutputType)
            Me.grp.Controls.Add(Me.btnOpenChapterlist)
            Me.grp.Controls.Add(Me.cbxCreateDVDMenu)
            Me.grp.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.grp.Location = New System.Drawing.Point(560, 8)
            Me.grp.Name = "grp"
            Me.grp.Size = New System.Drawing.Size(232, 272)
            Me.grp.TabIndex = 40
            Me.grp.TabStop = False
            Me.grp.Text = "Projekt Eigenschaften"
            '
            'grpAutoCut
            '
            Me.grpAutoCut.Controls.Add(Me.Label5)
            Me.grpAutoCut.Controls.Add(Me.updAsplit)
            Me.grpAutoCut.Controls.Add(Me.Label6)
            Me.grpAutoCut.Controls.Add(Me.lblVsplit2)
            Me.grpAutoCut.Controls.Add(Me.updVsplit)
            Me.grpAutoCut.Controls.Add(Me.lblVsplit)
            Me.grpAutoCut.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.grpAutoCut.Location = New System.Drawing.Point(8, 72)
            Me.grpAutoCut.Name = "grpAutoCut"
            Me.grpAutoCut.Size = New System.Drawing.Size(216, 64)
            Me.grpAutoCut.TabIndex = 57
            Me.grpAutoCut.TabStop = False
            Me.grpAutoCut.Text = "automatischer Schnitt"
            '
            'Label5
            '
            Me.Label5.Location = New System.Drawing.Point(136, 40)
            Me.Label5.Name = "Label5"
            Me.Label5.Size = New System.Drawing.Size(64, 16)
            Me.Label5.TabIndex = 7
            Me.Label5.Text = "Sequenzen"
            '
            'updAsplit
            '
            Me.updAsplit.Location = New System.Drawing.Point(96, 38)
            Me.updAsplit.Maximum = New Decimal(New Integer() {5, 0, 0, 0})
            Me.updAsplit.Minimum = New Decimal(New Integer() {1, 0, 0, -2147483648})
            Me.updAsplit.Name = "updAsplit"
            Me.updAsplit.Size = New System.Drawing.Size(40, 20)
            Me.updAsplit.TabIndex = 6
            '
            'Label6
            '
            Me.Label6.Location = New System.Drawing.Point(8, 40)
            Me.Label6.Name = "Label6"
            Me.Label6.Size = New System.Drawing.Size(96, 16)
            Me.Label6.TabIndex = 5
            Me.Label6.Text = "Audio-Split nach "
            '
            'lblVsplit2
            '
            Me.lblVsplit2.Location = New System.Drawing.Point(136, 16)
            Me.lblVsplit2.Name = "lblVsplit2"
            Me.lblVsplit2.Size = New System.Drawing.Size(64, 16)
            Me.lblVsplit2.TabIndex = 4
            Me.lblVsplit2.Text = "Sequenzen"
            '
            'updVsplit
            '
            Me.updVsplit.Location = New System.Drawing.Point(96, 14)
            Me.updVsplit.Maximum = New Decimal(New Integer() {5, 0, 0, 0})
            Me.updVsplit.Minimum = New Decimal(New Integer() {1, 0, 0, -2147483648})
            Me.updVsplit.Name = "updVsplit"
            Me.updVsplit.Size = New System.Drawing.Size(40, 20)
            Me.updVsplit.TabIndex = 3
            '
            'lblVsplit
            '
            Me.lblVsplit.Location = New System.Drawing.Point(8, 16)
            Me.lblVsplit.Name = "lblVsplit"
            Me.lblVsplit.Size = New System.Drawing.Size(96, 16)
            Me.lblVsplit.TabIndex = 2
            Me.lblVsplit.Text = "Video-Split nach "
            '
            'cbxGenerateIDD
            '
            Me.cbxGenerateIDD.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.cbxGenerateIDD.Location = New System.Drawing.Point(8, 192)
            Me.cbxGenerateIDD.Name = "cbxGenerateIDD"
            Me.cbxGenerateIDD.Size = New System.Drawing.Size(192, 24)
            Me.cbxGenerateIDD.TabIndex = 58
            Me.cbxGenerateIDD.Text = "MPEG2-Schnitt IDD erstellen"
            '
            'txtFilmLength
            '
            Me.txtFilmLength.BackColor = System.Drawing.SystemColors.Info
            Me.txtFilmLength.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            Me.txtFilmLength.Location = New System.Drawing.Point(168, 144)
            Me.txtFilmLength.Name = "txtFilmLength"
            Me.txtFilmLength.Size = New System.Drawing.Size(56, 20)
            Me.txtFilmLength.TabIndex = 54
            Me.txtFilmLength.Text = ""
            Me.txtFilmLength.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
            '
            'Label2
            '
            Me.Label2.Location = New System.Drawing.Point(8, 144)
            Me.Label2.Name = "Label2"
            Me.Label2.Size = New System.Drawing.Size(144, 16)
            Me.Label2.TabIndex = 53
            Me.Label2.Text = "Filmlnge in Minuten"
            Me.Label2.TextAlign = System.Drawing.ContentAlignment.BottomLeft
            '
            'txtChapterLength
            '
            Me.txtChapterLength.BackColor = System.Drawing.SystemColors.Info
            Me.txtChapterLength.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            Me.txtChapterLength.Location = New System.Drawing.Point(168, 168)
            Me.txtChapterLength.Name = "txtChapterLength"
            Me.txtChapterLength.Size = New System.Drawing.Size(32, 20)
            Me.txtChapterLength.TabIndex = 56
            Me.txtChapterLength.Text = ""
            Me.txtChapterLength.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
            '
            'Label3
            '
            Me.Label3.Location = New System.Drawing.Point(8, 168)
            Me.Label3.Name = "Label3"
            Me.Label3.Size = New System.Drawing.Size(144, 16)
            Me.Label3.TabIndex = 55
            Me.Label3.Text = "Kapitellnge in Minuten"
            Me.Label3.TextAlign = System.Drawing.ContentAlignment.BottomLeft
            '
            'cbxKeepDVDStructure
            '
            Me.cbxKeepDVDStructure.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.cbxKeepDVDStructure.Location = New System.Drawing.Point(8, 216)
            Me.cbxKeepDVDStructure.Name = "cbxKeepDVDStructure"
            Me.cbxKeepDVDStructure.Size = New System.Drawing.Size(192, 24)
            Me.cbxKeepDVDStructure.TabIndex = 44
            Me.cbxKeepDVDStructure.Text = "Vorhandene DVD Stuktur behalten"
            '
            'grpOutputType
            '
            Me.grpOutputType.Controls.Add(Me.optES)
            Me.grpOutputType.Controls.Add(Me.optMPG)
            Me.grpOutputType.Controls.Add(Me.optVOB)
            Me.grpOutputType.Controls.Add(Me.optDVD)
            Me.grpOutputType.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.grpOutputType.Location = New System.Drawing.Point(8, 16)
            Me.grpOutputType.Name = "grpOutputType"
            Me.grpOutputType.Size = New System.Drawing.Size(216, 48)
            Me.grpOutputType.TabIndex = 39
            Me.grpOutputType.TabStop = False
            Me.grpOutputType.Text = "Ausgabetyp"
            '
            'optES
            '
            Me.optES.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.optES.Location = New System.Drawing.Point(16, 16)
            Me.optES.Name = "optES"
            Me.optES.Size = New System.Drawing.Size(48, 24)
            Me.optES.TabIndex = 0
            Me.optES.Text = "ES"
            '
            'optMPG
            '
            Me.optMPG.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.optMPG.Location = New System.Drawing.Point(64, 16)
            Me.optMPG.Name = "optMPG"
            Me.optMPG.Size = New System.Drawing.Size(48, 24)
            Me.optMPG.TabIndex = 1
            Me.optMPG.Text = "MPG"
            '
            'optVOB
            '
            Me.optVOB.Checked = True
            Me.optVOB.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.optVOB.Location = New System.Drawing.Point(160, 16)
            Me.optVOB.Name = "optVOB"
            Me.optVOB.Size = New System.Drawing.Size(48, 24)
            Me.optVOB.TabIndex = 2
            Me.optVOB.TabStop = True
            Me.optVOB.Text = "VOB"
            '
            'optDVD
            '
            Me.optDVD.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.optDVD.Location = New System.Drawing.Point(112, 16)
            Me.optDVD.Name = "optDVD"
            Me.optDVD.Size = New System.Drawing.Size(48, 24)
            Me.optDVD.TabIndex = 3
            Me.optDVD.Text = "DVD"
            '
            'btnOpenChapterlist
            '
            Me.btnOpenChapterlist.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnOpenChapterlist.GenerateDisabledImage = True
            Me.btnOpenChapterlist.Location = New System.Drawing.Point(204, 166)
            Me.btnOpenChapterlist.Name = "btnOpenChapterlist"
            Me.btnOpenChapterlist.Size = New System.Drawing.Size(24, 24)
            Me.btnOpenChapterlist.TabIndex = 48
            Me.btnOpenChapterlist.Tag = "OpenChapterList"
            Me.btnOpenChapterlist.ThemedImage = Nothing
            Me.btnOpenChapterlist.SetImage(Images.Writeline)
            Me.QuickInfo.SetToolTip(Me.btnOpenChapterlist, "Kapitelliste bearbeiten/erstellen")
            '
            'cbxCreateDVDMenu
            '
            Me.cbxCreateDVDMenu.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.cbxCreateDVDMenu.Location = New System.Drawing.Point(8, 240)
            Me.cbxCreateDVDMenu.Name = "cbxCreateDVDMenu"
            Me.cbxCreateDVDMenu.Size = New System.Drawing.Size(200, 24)
            Me.cbxCreateDVDMenu.TabIndex = 48
            Me.cbxCreateDVDMenu.Text = "DVD Titelmen erstellen"
            '
            'btnDelProject
            '
            Me.btnDelProject.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnDelProject.Location = New System.Drawing.Point(767, 24)
            Me.btnDelProject.Name = "btnDelProject"
            Me.btnDelProject.Size = New System.Drawing.Size(24, 24)
            Me.btnDelProject.TabIndex = 46
            Me.btnDelProject.Tag = "DelProject"
            Me.btnDelProject.ThemedImage = Nothing
            Me.btnDelProject.SetImage(Images.Error)
            Me.QuickInfo.SetToolTip(Me.btnDelProject, "Markiertes Projekt lschen")
            '
            'btnNewProject
            '
            Me.btnNewProject.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnNewProject.Location = New System.Drawing.Point(767, 0)
            Me.btnNewProject.Name = "btnNewProject"
            Me.btnNewProject.Size = New System.Drawing.Size(24, 24)
            Me.btnNewProject.TabIndex = 45
            Me.btnNewProject.Tag = "NewProject"
            Me.btnNewProject.ThemedImage = Nothing
            Me.btnNewProject.SetImage(Images.Start)
            Me.QuickInfo.SetToolTip(Me.btnNewProject, "Neues Projekt anlegen")
            '
            'HelpBar
            '
            Me.HelpBar.Location = New System.Drawing.Point(0, 425)
            Me.HelpBar.Name = "HelpBar"
            Me.HelpBar.Size = New System.Drawing.Size(794, 22)
            Me.HelpBar.TabIndex = 47
            '
            'BottomFrame
            '
            Me.BottomFrame.Controls.Add(Me.btnDelProject)
            Me.BottomFrame.Controls.Add(Me.btnNewProject)
            Me.BottomFrame.Controls.Add(Me.ProjectList)
            Me.BottomFrame.Dock = System.Windows.Forms.DockStyle.Fill
            Me.BottomFrame.Location = New System.Drawing.Point(0, 320)
            Me.BottomFrame.Name = "BottomFrame"
            Me.BottomFrame.Size = New System.Drawing.Size(794, 105)
            Me.BottomFrame.TabIndex = 48
            '
            'ProjectList
            '
            Me.ProjectList.AllowDrop = True
            Me.ProjectList.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
            Me.ProjectList.AutoScroll = True
            Me.ProjectList.BackColor = System.Drawing.Color.White
            Me.ProjectList.Location = New System.Drawing.Point(0, 0)
            Me.ProjectList.Name = "ProjectList"
            Me.ProjectList.SelectedItem = Nothing
            Me.ProjectList.Size = New System.Drawing.Size(764, 105)
            Me.ProjectList.TabIndex = 1
            '
            'ImageButton1
            '
            Me.ImageButton1.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.ImageButton1.Location = New System.Drawing.Point(688, 288)
            Me.ImageButton1.Name = "ImageButton1"
            Me.ImageButton1.Size = New System.Drawing.Size(24, 24)
            Me.ImageButton1.TabIndex = 48
            Me.ImageButton1.Tag = ""
            Me.ImageButton1.ThemedImage = Nothing
            Me.QuickInfo.SetToolTip(Me.ImageButton1, "Output Verzeichnis whlen")
            '
            'ProjectDialog
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(794, 447)
            Me.Controls.Add(Me.BottomFrame)
            Me.Controls.Add(Me.HelpBar)
            Me.Controls.Add(Me.CenterFrame)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            Me.MaximumSize = New System.Drawing.Size(800, 500)
            Me.Menu = Me.MainMenu
            Me.MinimumSize = New System.Drawing.Size(800, 450)
            Me.Name = "ProjectDialog"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
            Me.grpStreams.ResumeLayout(False)
            Me.CenterFrame.ResumeLayout(False)
            Me.grp.ResumeLayout(False)
            Me.grpAutoCut.ResumeLayout(False)
            CType(Me.updAsplit, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.updVsplit, System.ComponentModel.ISupportInitialize).EndInit()
            Me.grpOutputType.ResumeLayout(False)
            Me.BottomFrame.ResumeLayout(False)
            Me.ResumeLayout(False)

        End Sub

#End Region


#Region " Verarbeitung der notwendigen berprfungen beim Start des Formulars"
        Private Sub StreamSelectionDialog_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Me.SuspendLayout()
            If System.IO.File.Exists(Settings.Programm.XMLBatchFile) Then
                Dim Projects As ArrayList

                Projects = OUTPUT.XMLBatchFile.Load(Settings.Programm.XMLBatchFile)

                If Projects.Count = 0 Then
                    Me.ProjectList.Add()

                Else
                    Me.ProjectList.Items = Projects
                    'Die Batch-Datei wird ohne Projekte neu angelegt, um zu signalisieren,
                    'dass eine Verarbeitung luft.
                    OUTPUT.XMLBatchFile.Save(New ArrayList, Settings.Programm.XMLBatchFile)
                End If
            Else
                Me.ProjectList.Add()
            End If
            Me.ResumeLayout()
        End Sub
#End Region

#Region " Verarbeitung der nderung OutputTypes und Durchfhrung der entsprechenden nderungen auf dem Formular"
        Private Sub OutputType_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDVD.CheckedChanged, optES.CheckedChanged, optMPG.CheckedChanged, optVOB.CheckedChanged
            If Me.ProjectList.Items.Count = 0 Then Exit Sub

            Dim curRadio As RadioButton = CType(sender, RadioButton)

            Select Case curRadio.Text
                Case "ES"
                    If curRadio.Checked Then Me.SelectedProject.Type = DATA.ProjectType.ES
                    Me.btnNewStream.Enabled = False
                Case "MPG"
                    If curRadio.Checked Then Me.SelectedProject.Type = DATA.ProjectType.MPG
                    Me.btnNewStream.Enabled = False
                Case "DVD"
                    If curRadio.Checked Then Me.SelectedProject.Type = DATA.ProjectType.DVD
                    Me.btnNewStream.Enabled = True
                Case "VOB"
                    If curRadio.Checked Then Me.SelectedProject.Type = DATA.ProjectType.VOB
                    Me.btnNewStream.Enabled = False
            End Select
        End Sub

        Private Sub SetOutputType(ByVal OutputType As DATA.ProjectType)
            Select Case OutputType
                Case DATA.ProjectType.ES
                    Me.optES.Checked = True
                Case DATA.ProjectType.MPG
                    Me.optMPG.Checked = True
                Case DATA.ProjectType.DVD
                    Me.optDVD.Checked = True
                Case DATA.ProjectType.VOB
                    Me.optVOB.Checked = True
            End Select
        End Sub

        Private Sub EnableOutputType()
            If Me.StreamTree.Count > 1 Then
                If Me.StreamTree.Count > 1 Then
                    Me.optES.Enabled = False
                    Me.optMPG.Enabled = False
                    Me.optVOB.Enabled = False
                End If
            Else
                Select Case Me.SelectedStream.InputType
                    Case DATA.InputType.ES
                        Me.optES.Enabled = False
                        Me.optMPG.Enabled = True
                        If Me.optES.Checked Then Me.optMPG.Checked = True

                    Case DATA.InputType.PES
                        Me.optES.Enabled = True
                        Me.optMPG.Enabled = True
                End Select
                Me.optVOB.Enabled = True
            End If
        End Sub
#End Region

#Region " SelectedProject und SelectedStream Eigenschaft fr schnelleren Zugriff auf diese Objekte"
        Private ReadOnly Property SelectedProject() As Data.Project
            Get
                Return Me.ProjectList.SelectedItem.Project
            End Get
        End Property

        Private ReadOnly Property SelectedStream() As Muxxi.Data.Movie
            Get
                If Me.StreamTree.SelectedNode Is Nothing Then Return Me.SelectedProject.Movies(0)
                Return Me.StreamTree.SelectedStreamNode.Movie
            End Get
        End Property
#End Region

#Region " Aktualisierung der Steuerelemente auf dem Formulars"
        Private Sub StreamTree_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles StreamTree.AfterSelect
            Call ActualizeControls()
        End Sub

        Private Sub ProjectList_SelectionChanged() Handles ProjectList.SelectionChanged
            Me.StreamTree.Project = Me.SelectedProject
            Me.ActualizeControls()
        End Sub

        Private Sub ActualizeControls()
            'Alles Aktualisieren
            Me.txtProjectName.Text = Me.SelectedProject.Text
            Me.txtOutput.Text = Me.SelectedProject.OutputPath
            Me.SetOutputType(Me.SelectedProject.Type)
            Me.txtFilmLength.Text = Me.SelectedStream.FilmLength
            Me.txtChapterLength.Text = Me.SelectedStream.ChapterLength

            If Me.SelectedStream.ChapterDialog = String.Empty Then
                Me.txtChapterLength.Enabled = True
            Else
                Me.txtChapterLength.Enabled = False
            End If

            Me.cbxKeepDVDStructure.Checked = Me.SelectedProject.KeepDVDStructure
            Me.cbxCreateDVDMenu.Checked = Me.SelectedProject.CreateDVDMenu
            Me.updVsplit.Value = Me.SelectedStream.VSplit
            Me.updAsplit.Value = Me.SelectedStream.ASplit
            Me.cbxGenerateIDD.Checked = Me.SelectedStream.GenerateIDD

            Me.EnableOutputType()

            If Me.SelectedStream.Video.FullPath = String.Empty Then
                Me.HelpBar.Text = String.Empty
            Else
                'Me.HelpBar.Text = Me.SelectedStream.VideoFrameInfo.PictureInformation
            End If
        End Sub
#End Region

#Region " Genderte Werte an Me.SelectedProject bergeben um Me.ProjectList.SelectedItem aktualisieren"
        Private Sub txtProjectName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtProjectName.TextChanged
            Me.SelectedProject.Text = Me.txtProjectName.Text
        End Sub

        Private Sub txtOutput_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtOutput.TextChanged
            Me.SelectedProject.OutputPath = Me.txtOutput.Text
        End Sub

        Private Sub txtFilmLength_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFilmLength.TextChanged
            Me.SelectedStream.FilmLength = Me.txtFilmLength.Text
        End Sub

        Private Sub txtChapterLength_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtChapterLength.TextChanged
            Me.SelectedStream.ChapterLength = Me.txtChapterLength.Text
        End Sub

        Private Sub updVsplit_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updVsplit.ValueChanged
            Me.SelectedStream.VSplit = Me.updVsplit.Value
        End Sub

        Private Sub updAsplit_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updAsplit.ValueChanged
            Me.SelectedStream.ASplit = Me.updAsplit.Value
        End Sub

        Private Sub cbxGenerateIDD_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxGenerateIDD.CheckedChanged
            Me.SelectedStream.GenerateIDD = Me.cbxGenerateIDD.Checked
        End Sub

        Private Sub cbxKeepDVDStructure_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxKeepDVDStructure.CheckedChanged
            Me.SelectedProject.KeepDVDStructure = Me.cbxKeepDVDStructure.Checked
        End Sub

        Private Sub cbxCreateMenu_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxCreateDVDMenu.CheckedChanged
            Me.SelectedProject.CreateDVDMenu = Me.cbxCreateDVDMenu.Checked
        End Sub

        'Ereignisse von Controls, um eine Aktualisierung zu erzwingen
        Private Sub StreamTree_ActualizeOutput(ByVal Output As String) Handles StreamTree.ActualizeOutput
            Me.txtOutput.Text = Output
        End Sub

        Private Sub StreamTree_StreamCountChanged() Handles StreamTree.StreamCountChanged
            ProjectList.SelectedItem.Invalidate()
            Me.EnableOutputType()
        End Sub
#End Region

#Region " Klick-Ereignisse smtlicher Toolbars, Buttons"
        'ProjectBar.ButtonClick
        Private Sub ProjectBar_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewProject.Click, btnDelProject.Click
            Dim Clicked As Button = DirectCast(sender, System.Windows.Forms.Button)

            Select Case Clicked.Tag.ToString
                Case "NewProject"
                    Me.ProjectList.Add()
                Case "DelProject"
                    Me.ProjectList.DeleteSelected()
            End Select
        End Sub

        'StreamBar.ButtonClick
        Private Sub StreamBar_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewStream.Click, btnEditVideo.Click, btnAddAudio.Click, btnDelElement.Click
            Dim Clicked As Button = DirectCast(sender, System.Windows.Forms.Button)

            Select Case Clicked.Tag.ToString
                Case "NewStream"
                    Me.StreamTree.NewStream()
                Case "EditVideo"
                    Me.StreamTree.AddVideo()
                Case "AddAudio"
                    Me.StreamTree.AddAudio()
                Case "DelElement"
                    Me.StreamTree.DeleteSelected()
            End Select
        End Sub

        'Verschieben von Elementen im StreamTree
        Private Sub btnUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUp.Click
            Me.StreamTree.MoveUp()
            Me.EnableOutputType()
        End Sub

        Private Sub btnDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDown.Click
            Me.StreamTree.MoveDown()
            Me.EnableOutputType()
        End Sub

        'OpenChapterlist
        Private Sub btnOpenChapterlist_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenChapterlist.Click
            Dim ChapterDialog As New UI.ChapterDialog

            ChapterDialog.ChapterDialog = Me.SelectedStream.ChapterDialog

            If ChapterDialog.ShowDialog() = DialogResult.OK Then
                Me.SelectedStream.ChapterDialog = ChapterDialog.ChapterDialog

                If Me.SelectedStream.ChapterDialog = String.Empty Then
                    Me.txtChapterLength.Enabled = True
                Else
                    Me.txtChapterLength.Enabled = False
                End If
            End If
        End Sub

        'Starten der Verarbeitung
        Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles start.Click
            If Me.ProjectList.Items.Count = 1 AndAlso Me.SelectedStream.Video.FullPath = String.Empty Then
                MessageBox.Show("Es wurde noch kein Film angelegt, daher wird die Verarbeitung abgebrochen!", Settings.Programm.Name, MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If

            If File.Exists(Settings.Programm.XMLBatchFile) Then
                OUTPUT.XMLBatchFile.AddProjects(Me.ProjectList.Items, Settings.Programm.XMLBatchFile, OUTPUT.XMLBatchFile.Position.Last)
                Me.DialogResult = DialogResult.Cancel
            Else
                OUTPUT.XMLBatchFile.Save(Me.ProjectList.Items, Settings.Programm.XMLBatchFile)
                Me.DialogResult = DialogResult.OK
            End If
        End Sub

        'Damit wird der ProjektName aus dem Basis-Namen des
        'selektierten Streams plus Datum gebildet
        Private Sub btnActualizeName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActualizeName.Click
            If Me.SelectedStream.Text.StartsWith("Neuer Film") Then Exit Sub
            Me.txtProjectName.Text = String.Format("{0} {1:yyyy-MM-dd}", Me.SelectedStream.Text, Now)
        End Sub

        'ffnet einen FolderBrowser um ein Zielverzeichnis auswhlen zu knnen
        Private Sub btnOutputFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOutputFolder.Click
            Dim Folder As New FolderBrowserDialog
            Dim strFolder As String
            Folder.Description = "Output-Folder whlen..."
            If Folder.ShowDialog Then
                Me.txtOutput.Text = Folder.SelectedPath
            End If
        End Sub
#End Region

#Region " Verarbeitung der Men-Aktionen"
        Private Sub mniStandardSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniStandardSettings.Click
            Dim dlgSettings As New SettingsDialog
            dlgSettings.ShowDialog()
        End Sub

        Private Sub mniOpenProject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniOpenProject.Click
            Dim OpenDialog As New OpenFileDialog

            OpenDialog.Filter = "Muxxi Projekt (*.mpf)|*.mpf|Alle Dateien (*.*)|*.*"
            OpenDialog.Multiselect = False
            OpenDialog.FilterIndex = 0

            With OpenDialog
                .RestoreDirectory = True
                .AddExtension = True
                .CheckFileExists = True
                .FileName = String.Empty
            End With

            If OpenDialog.ShowDialog() = DialogResult.OK Then
                Dim Projects As ArrayList = OUTPUT.XMLBatchFile.Load(OpenDialog.FileName)

                If Projects.Count = 0 Then
                    Me.ProjectList.Add()
                Else
                    Me.ProjectList.Items = Projects
                End If
            End If
        End Sub

        Private Sub mniSaveAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniSaveAll.Click
            Dim FileName As String
            FileName = String.Format("Projektliste {0:yyyy-MM-dd}", Now)

            Call SaveProjects(Me.ProjectList.Items, FileName)
        End Sub

        Private Sub mniSaveCurrent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mniSaveCurrent.Click
            Dim Projects As New ArrayList
            Projects.Add(Me.SelectedProject)

            Call SaveProjects(Projects, Me.SelectedProject.Text)
        End Sub

        Private Sub SaveProjects(ByVal Projects As ArrayList, ByVal Text As String)
            Dim SaveDialog As New SaveFileDialog

            SaveDialog.Filter = "Muxxi Projekt (*.mpf)|*.mpf|Alle Dateien (*.*)|*.*"
            SaveDialog.FilterIndex = 0

            With SaveDialog
                .Title = String.Format("{0} speichern", Text)
                .RestoreDirectory = True
                .AddExtension = True
                .CheckFileExists = False
                .FileName = String.Format("{0}.mpf", Functions.GetLegalFilename(Text))
            End With

            If SaveDialog.ShowDialog() = DialogResult.OK Then
                OUTPUT.XMLBatchFile.Save(Projects, SaveDialog.FileName)
            End If
        End Sub
#End Region

#Region " Drag and Drop Ereignisse sowie alle Verarbeitungsschritte"
        Private Sub StreamTree_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles StreamTree.MouseMove
            If e.Button = MouseButtons.Left Then
                If StreamTree.Count > 1 Then
                    Dim Node As TreeNode = StreamTree.GetNodeAt(Me.StreamTree.PointToClient(Me.StreamTree.MousePosition))
                    Dim StreamNode As UI.StreamNode

                    If Not Node Is Nothing Then StreamTree.SelectedNode = Node
                    StreamNode = StreamTree.SelectedStreamNode

                    StreamTree.DoDragDrop(StreamNode.Movie, DragDropEffects.All)
                End If
            End If
        End Sub

        Private Sub StreamTree_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles StreamTree.DragOver
            If e.Data.GetDataPresent(DataFormats.FileDrop) Then
                Dim Helptext As String
                e.Effect = DragDropEffects.Move

                Select Case e.KeyState
                    Case 1          'linke Maustaste
                        e.Effect = DragDropEffects.Move
                        Helptext = "SHIFT fr nur Video-Dateien"

                    Case 1 + 4      'linke Maustaste + SHIFT
                        e.Effect = DragDropEffects.Move
                        Helptext = "Nur Video-Dateien bernehmen"

                    Case Else
                        e.Effect = DragDropEffects.None
                        Helptext = "SHIFT fr nur Video-Dateien"
                End Select

                If Not Me.HelpBar.Text = Helptext Then Me.HelpBar.Text = Helptext
            End If
        End Sub

        Private Sub ProjectList_DragOver(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ProjectList.DragOver
            If e.Data.GetDataPresent(GetType(Muxxi.Data.Movie)) OrElse e.Data.GetDataPresent(DataFormats.FileDrop) Then
                Dim Helptext As String
                Select Case e.KeyState
                    Case 1          'linke Maustaste
                        e.Effect = DragDropEffects.Move
                        Helptext = "STRG fr ein Projekt mit mehreren Streams, SHIFT fr nur Video-Dateien"

                    Case 1 + 4      'linke Maustaste + SHIFT
                        e.Effect = DragDropEffects.Move
                        Helptext = "Nur Video-Dateien bernehmen"

                    Case 1 + 8       'linke Maustaste + STRG
                        e.Effect = DragDropEffects.Copy
                        Helptext = "Ein Projekt mit mehreren Streams"

                    Case 1 + 8 + 4   'linke Maustaste + SHIFT + STRG
                        e.Effect = DragDropEffects.Copy
                        Helptext = "Ein Projekt mit mehreren Streams und nur Video-Dateien bernehmen"

                    Case Else
                        e.Effect = DragDropEffects.None
                        Helptext = "STRG fr ein Projekt mit mehreren Streams, SHIFT fr nur Video-Dateien"
                End Select
                'Der Text wird nur neu geschrieben, wenn er gendert werden muss
                'so flackert der Text nicht whrend die Maus bewegt wird
                If Not Me.HelpBar.Text = Helptext Then Me.HelpBar.Text = Helptext
            End If
        End Sub

        Private Sub StreamTree_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles StreamTree.DragDrop
            'Es wird der Datentyp geprft, der bergeben werden soll
            If e.Data.GetDataPresent(DataFormats.FileDrop) Then
                Dim Files() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
                Dim OnlyVideo As Boolean = False
                If e.KeyState = 4 OrElse e.KeyState = 12 Then OnlyVideo = True

                Dim Node As TreeNode = StreamTree.GetNodeAt(Me.StreamTree.PointToClient(Me.StreamTree.MousePosition()))
                If Not Node Is Nothing Then StreamTree.SelectedNode = Node
                'Wenn sich kein Knoten unter dem Mauszeiger befindet, dann
                'wird geprft, ob der zuletzt markierte bereits eine Video-Datei
                'enhlt. Ist keine vorhanden werden die Daten an diesen Knoten
                'bergeben. Sind welche vorhanden, wird ein komplett neuer Knoten
                'angelegt

                If Not Me.SelectedStream.Video.FullPath = String.Empty AndAlso Me.SelectedProject.Type = DATA.ProjectType.DVD Then
                    StreamTree.NewStream()
                End If

                ProcessDrop(Files, MessageResultEnum.Add, OnlyVideo)
            End If
        End Sub

        Private Sub ProjectList_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles ProjectList.DragDrop
            'Es wird der Datentyp geprft, der bergeben werden soll
            If e.Data.GetDataPresent(DataFormats.FileDrop) Then
                Dim Files() As String = CType(e.Data.GetData(DataFormats.FileDrop), String())
                Dim MessageResult As MessageResultEnum

                Dim OnlyVideo As Boolean = False
                If e.KeyState = 4 OrElse e.KeyState = 12 Then OnlyVideo = True

                'bergabe eines Ordners an die ProjectList
                If e.Data.GetDataPresent(DataFormats.FileDrop) Then
                    Dim Count As Int16 = CountFolders(Files)
                    Select Case Count
                        Case 0, 1
                            DropFiles(Files, True, OnlyVideo)
                        Case Else
                            Select Case e.KeyState
                                Case 8, 12
                                    MessageResult = MessageResultEnum.One
                                Case 0, 4
                                    MessageResult = MessageResultEnum.Many
                                Case Else
                                    Exit Sub
                            End Select

                            ProcessDrop(Files, MessageResult, OnlyVideo)
                    End Select
                End If

                'Ein Film wird auf die ProjectList gezogen
            ElseIf e.Data.GetDataPresent(GetType(Data.Movie)) Then
                Dim Movie As DATA.Movie = CType(e.Data.GetData(GetType(DATA.Movie)), DATA.Movie)
                Me.SelectedProject.Movies.Remove(Movie)

                If TypeOf sender Is UI.ProjectList Then
                    'bergabe eines Streams an die ProjektListe
                    Me.DropStream(Movie, True)

                ElseIf TypeOf sender Is UI.ProjectListItem Then
                    'bergabe eines Streams an ein ProjectListItem
                    Me.ProjectList.SelectedItem = CType(sender, UI.ProjectListItem)
                    Me.StreamTree.Project = Me.SelectedProject
                    Me.ActualizeControls()

                    If e.KeyState = 8 Then
                        If Me.SelectedStream.Video.FullPath = String.Empty Then
                            Me.DropStream(Movie, False)
                        Else
                            Me.DropStream(Movie, True)
                        End If
                    Else
                        If Me.SelectedProject.Type = DATA.ProjectType.DVD OrElse Me.SelectedStream.Video.FullPath = String.Empty Then
                            Me.DropStream(Movie, False)
                        Else
                            Me.DropStream(Movie, True)
                        End If

                    End If
                End If
            End If
        End Sub

        Private Sub ProcessDrop(ByVal Files() As String, ByVal MessageResult As MessageResultEnum, ByVal OnlyVideo As Boolean)
            'Der Hilfetext wird wieder auf String.Empty gestellt
            Me.HelpBar.Text = String.Empty

            'Es wird geprft, ob nur Video-Dateien eingefgt werden sollen
            'Ist dem nicht so wird berprft ob der entsprechende Dialog
            'angezeigt werden kann. Entsprechend wird es angezeigt und das
            'Resultat verarbeitet.
            If Not OnlyVideo AndAlso Not Settings.Tipps.SHIFT_OnlyVideo Then
                Select Case MessageDialog.Show(String.Format("Wenn Sie whrend des Hinzufgens von Streams{0}mittels Drag'n Drop die SHIFT-Taste gedrckt{0}halten, dann bercksichtigt Muxxi beim Anlegen{0}der neuen Streams nur Video-Dateien und{0}whlt erst bei der weiteren Verarbeitung{0}selbstndig die notwendigen Audio-Dateien aus!", Constants.vbCrLf), "Hinweis", MessageButtonEnum.OkCancel, MessageIconEnum.Information, True)
                    Case MessageResultEnum.Cancel
                        Exit Sub
                End Select

                'Wenn der User den Hacken bei 'Nicht mehr anzeigen' gesetzt hat,
                'dann wird dies sofort gespeichert und knftig nicht mehr angezeigt
                Settings.Tipps.SHIFT_OnlyVideo = MessageDialog.ShowAgain
            End If


            'Auswertung der MessageResults und entsprechende Verarbeitung
            'der per Drag'n Drop ausgewhlten Dateien und Verzeichnisse
            'TODO: Geschwindigkeit der Dateierkennung bei Drag 'n' Drop optimieren
            Dim start As DateTime = Now
            Me.SuspendLayout()
            Select Case MessageResult
                Case MessageResultEnum.Add
                    If Me.SelectedProject.Type = DATA.ProjectType.DVD Then
                        DropFiles(Files, False, OnlyVideo)
                    Else
                        MessageBox.Show("Mehrere Filme in einem Projekt sind nur bei einer DVD mglich." & ControlChars.NewLine & _
                                        "Bitte legen Sie fr den zweiten Film ein neues Projekt an, um" & ControlChars.NewLine & _
                                        "eine gleichzeitige Verarbeitung zu ermglichen.", "Muxxi", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If

                Case MessageResultEnum.One
                    'Es wird ein neues Projekt angelegt und fr jedes Verzeichnis
                    'ein Film erzeugt. Auerdem wird unabhngig von der Voreinstellung
                    'der ProjektTyp auf 'DVD' gestellt
                    If Not Me.SelectedStream.Video.FullPath = String.Empty Then ProjectList.Add()
                    Me.SetOutputType(DATA.ProjectType.DVD)
                    DropFiles(Files, False, OnlyVideo)

                Case MessageResultEnum.Many
                    'Es wird fr jedes Verzeichnis ein Projekt mit jeweils einem Film angelegt
                    DropFiles(Files, True, OnlyVideo)
            End Select
            Me.ResumeLayout()
            Console.WriteLine(Now.Subtract(start).ToString)
        End Sub

        'Prfung, ob es sich bei den Daten um Dateien oder Verzeichnisse handelt
        'sowie die Anzahl der Verzeichnisse
        Private Function CountFolders(ByVal Folders As String()) As Int16
            Dim CountFolder As Int16 = 0
            Dim CountRoot As Int16 = 0

            For Each Folder As String In Folders
                If New DirectoryInfo(Folder).Attributes.ToString = "Directory" _
                OrElse System.IO.Path.GetExtension(Folder) = String.Empty Then

                    'TODO: Nur nach gltigen Dateitypen suchen
                    Dim CountFiles() As String = Muxxi.Functions.GetFiles(New System.IO.DirectoryInfo(Folder), "*.mpv;*.mp2;*.ac3;*.vpes;*.apes")

                    If CountFiles.Length = 0 Then
                        CountFolder += CountFolders(Functions.GetFolders(New System.IO.DirectoryInfo(Folder)))
                    Else
                        CountFolder += 1
                    End If
                Else
                    Select Case System.IO.Path.GetExtension(Folder)
                        Case ".mpv", ".mp2", ".ac3", ".vpes", ".apes"
                            CountRoot = 1
                    End Select
                End If
            Next

            Return CountFolder + CountRoot
        End Function

        Private Sub DropStream(ByVal Movie As DATA.Movie, ByVal CreateProject As Boolean)
            If CreateProject Then Me.ProjectList.Add()

            If Me.SelectedProject.OutputPath = String.Empty Then
                Me.SelectedProject.SetOutput(Movie)
            End If

            If Me.SelectedStream.Video.FullPath = String.Empty Then
                Me.SelectedProject.Movies(0) = Movie
            Else
                Me.SelectedProject.AddMovie(Movie)
            End If

            Me.StreamTree.Repaint(Movie)
        End Sub

        Private Sub DropFiles(ByVal Files As String(), ByVal CreateProjects As Boolean, ByVal OnlyVideo As Boolean)
            If CreateProjects Then
                If Not Me.SelectedStream.Video.FullPath = String.Empty Then ProjectList.Add()
            End If

            If Not Me.SelectedStream.Video.FullPath = String.Empty Then StreamTree.NewStream()

            For Each File As String In Files
                If Not New DirectoryInfo(File).Attributes.ToString = "Directory" _
                    AndAlso Not System.IO.Path.GetExtension(File) = String.Empty Then

                    Dim MediaFile As MultiMediaFile.ScanFile = New MultiMediaFile.ScanFile(File)

                    Select Case MediaFile.FileType
                        Case MultiMediaFile.FileType.Audio
                            If Not OnlyVideo Then StreamTree.AddAudio(File, MediaFile.AudioInfo)

                        Case MultiMediaFile.FileType.Video
                            StreamTree.AddVideo(File, MediaFile.VideoInfo, MediaFile.IsPES)
                    End Select
                End If
            Next
            DropFolders(Files, CreateProjects, OnlyVideo)
        End Sub

        Private Sub DropFolders(ByVal Folders As String(), ByVal CreateProjects As Boolean, ByVal OnlyVideo As Boolean)
            For Each Folder As String In Folders
                If New DirectoryInfo(Folder).Attributes.ToString = "Directory" _
                OrElse System.IO.Path.GetExtension(Folder) = String.Empty Then

                    'TODO: Nur nach gltigen Dateitypen suchen
                    Dim Files() As String = Muxxi.Functions.GetFiles(New System.IO.DirectoryInfo(Folder), "*.mpv;*.mp2;*.ac3;*.vpes;*.apes")
                    'Dim Files() As String = Muxxi.Functions.GetFiles(New System.IO.DirectoryInfo(Folder), "*.*")

                    If Files.Length = 0 Then
                        DropFolders(Functions.GetFolders(New System.IO.DirectoryInfo(Folder)), CreateProjects, OnlyVideo)
                    Else
                        If CreateProjects Then
                            If Not Me.SelectedStream.Video.FullPath = String.Empty Then ProjectList.Add()
                        End If

                        DropFiles(Files, False, OnlyVideo)
                    End If
                End If
            Next
        End Sub
#End Region

        Private Sub ImageButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImageButton1.Click
            Dim form As New Form1


            form.ProjectStructure1.BeginUpdate()

            For Each Project As Data.Project In Me.ProjectList.Items
                form.ProjectStructure1.Projects.Add(Project)
            Next

            If Not form.ProjectStructure1.Projects.Count = 0 Then
                form.ProjectStructure1.SelectedProject = form.ProjectStructure1.Projects(0)
            End If
            form.ProjectStructure1.EndUpdate()

            form.ShowDialog()
        End Sub
    End Class
End Namespace