Namespace UI
    Public Class SettingsDialog
        Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

        Public Sub New()
            MyBase.New()

            ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
            InitializeComponent()

            ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
            Me.Output = New Settings.Panel_Output
            Me.Temp = New Settings.Panel_Temp
            Me.DVD = New Settings.Panel_DVD
            Me.DVDMenu = New Settings.Panel_DVDMenu
            Me.Udrec = New Settings.Panel_Udrec
            Me.Automatical = New Settings.Panel_Automatical
            Me.LOG = New Settings.Panel_LOG
            Me.Files = New Settings.Panel_Files

            Me.Output.Dock = DockStyle.Fill
            Me.Temp.Dock = DockStyle.Fill
            Me.DVD.Dock = DockStyle.Fill
            Me.DVDMenu.Dock = DockStyle.Fill
            Me.Udrec.Dock = DockStyle.Fill
            Me.Automatical.Dock = DockStyle.Fill
            Me.LOG.Dock = DockStyle.Fill
            Me.Files.Dock = DockStyle.Fill
        End Sub

        ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        ' Fr Windows Form-Designer erforderlich
        Private components As System.ComponentModel.IContainer

        'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
        'Sie kann mit dem Windows Form-Designer modifiziert werden.
        'Verwenden Sie nicht den Code-Editor zur Bearbeitung.

        Private Output As Settings.Panel_Output
        Private Temp As Settings.Panel_Temp
        Private DVD As Settings.Panel_DVD
        Private DVDMenu As Settings.Panel_DVDMenu
        Private Udrec As Settings.Panel_Udrec
        Private Automatical As Settings.Panel_Automatical
        Private LOG As Settings.Panel_LOG
        Private Files As Settings.Panel_Files
        Friend WithEvents btnAbort As System.Windows.Forms.Button
        Friend WithEvents pnlSettings As System.Windows.Forms.Panel
        Friend WithEvents SettingsTree As System.Windows.Forms.TreeView
        Friend WithEvents btnOK As System.Windows.Forms.Button

        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.btnOK = New System.Windows.Forms.Button
            Me.btnAbort = New System.Windows.Forms.Button
            Me.pnlSettings = New System.Windows.Forms.Panel
            Me.SettingsTree = New System.Windows.Forms.TreeView
            Me.SuspendLayout()
            '
            'btnOK
            '
            Me.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnOK.Location = New System.Drawing.Point(320, 296)
            Me.btnOK.Name = "btnOK"
            Me.btnOK.TabIndex = 11
            Me.btnOK.Text = "OK"
            '
            'btnAbort
            '
            Me.btnAbort.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnAbort.Location = New System.Drawing.Point(400, 296)
            Me.btnAbort.Name = "btnAbort"
            Me.btnAbort.TabIndex = 10
            Me.btnAbort.Text = "Abbrechen"
            '
            'pnlSettings
            '
            Me.pnlSettings.Location = New System.Drawing.Point(176, 8)
            Me.pnlSettings.Name = "pnlSettings"
            Me.pnlSettings.Size = New System.Drawing.Size(296, 280)
            Me.pnlSettings.TabIndex = 9
            '
            'SettingsTree
            '
            Me.SettingsTree.HideSelection = False
            Me.SettingsTree.ImageIndex = -1
            Me.SettingsTree.Location = New System.Drawing.Point(8, 8)
            Me.SettingsTree.Name = "SettingsTree"
            Me.SettingsTree.Nodes.AddRange(New System.Windows.Forms.TreeNode() {New System.Windows.Forms.TreeNode("Output"), New System.Windows.Forms.TreeNode("Temp"), New System.Windows.Forms.TreeNode("UDREC"), New System.Windows.Forms.TreeNode("automatische Verarbeitung"), New System.Windows.Forms.TreeNode("LOG"), New System.Windows.Forms.TreeNode("DVD"), New System.Windows.Forms.TreeNode("DVD-Men"), New System.Windows.Forms.TreeNode("Dateien")})
            Me.SettingsTree.Scrollable = False
            Me.SettingsTree.SelectedImageIndex = -1
            Me.SettingsTree.Size = New System.Drawing.Size(160, 280)
            Me.SettingsTree.TabIndex = 8
            '
            'SettingsDialog
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(482, 328)
            Me.Controls.Add(Me.btnOK)
            Me.Controls.Add(Me.btnAbort)
            Me.Controls.Add(Me.pnlSettings)
            Me.Controls.Add(Me.SettingsTree)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
            Me.Name = "SettingsDialog"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
            Me.Text = "Einstellungen"
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private Sub SelectNode(ByVal Text As String)
            Dim Node As TreeNode

            For Each Node In Me.SettingsTree.Nodes
                If Node.Text = Text Then
                    Me.SettingsTree.SelectedNode = Node
                    Exit For
                End If
            Next
        End Sub

#Region " Formular bezogene Ereignisse"
        Private Sub Settings_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles SettingsTree.AfterSelect
            Select Case Me.SettingsTree.SelectedNode.Text
                Case "Output"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(Output)
                Case "Temp"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(Temp)
                Case "DVD"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(DVD)
                Case "DVD-Men"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(DVDMenu)
                Case "UDREC"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(Udrec)
                Case "automatische Verarbeitung"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(Automatical)
                Case "LOG"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(LOG)
                Case "Dateien"
                    Me.pnlSettings.Controls.Clear()
                    Me.pnlSettings.Controls.Add(Files)
            End Select
        End Sub

        Private Sub SettingsDialog_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'Generelle Einstellungen
            'Es wird nur der Verarbeitungs-Typ gespeichert

            'Output
            Me.Output.Type = Settings.Output.Type
            Me.Output.Folder = Settings.Output.Folder
            Me.Output.AutoSubfolder = Settings.Output.AutoSubfolder

            'Temp
            Me.Temp.Use = Settings.Temp.Use
            Me.Temp.Folder = Settings.Temp.Folder
            Me.Temp.DeleteES = Settings.Temp.DeleteES
            Me.Temp.DeleteMPG = Settings.Temp.DeleteMPG
            Me.Temp.DeleteDVD = Settings.Temp.DeleteDVD

            'DVD Einstellungen
            Me.DVD.StandardLanguage = DATA.LanguageList.Standard
            Me.DVD.OriginalLanguage = DATA.LanguageList.Original
            Me.DVD.FilmLength = Settings.DVD.FilmLength
            Me.DVD.ChapterLength = Settings.DVD.ChapterLength
            Me.DVD.KeepDVDStructure = Settings.DVD.KeepDVDStructure
            Me.DVD.SaveEPGinOutput = Settings.DVD.SaveEPGinOutput
            Me.DVD.UseDVDauthor_0_6_10 = Settings.DVD.UseDVDauthor_0_6_10

            'DVD-Men Einstellungen
            Me.DVDMenu.Background = Settings.DVDMenu.Background
            Me.DVDMenu.BackgroundColor = Settings.DVDMenu.BackgroundColor
            Me.DVDMenu.TitleColor = Settings.DVDMenu.TitleColor
            Me.DVDMenu.ButtonColor = Settings.DVDMenu.ButtonColor
            Me.DVDMenu.HighlightColor = Settings.DVDMenu.HighlightColor
            Me.DVDMenu.SelectedColor = Settings.DVDMenu.SelectColor
            Me.DVDMenu.ShowDVDTitle = Settings.DVDMenu.ShowDVDTitle
            Me.DVDMenu.PauseAfterTitle = Settings.DVDMenu.PauseAfterTitle

            'UDREC PES Streams
            Me.Udrec.RewriteGTC = Settings.Udrec.RewriteGTC
            Me.Udrec.GenerateIDD = Settings.Udrec.GenerateIDD
            Me.Udrec.UseMinSyncCount = Settings.Udrec.UseMinSyncCount
            Me.Udrec.MinSyncCount = Settings.Udrec.MinSyncCount
            Me.Udrec.VSplit = Settings.Udrec.VSplit
            Me.Udrec.ASplit = Settings.Udrec.ASplit

            'automatische Verarbeitung
            Me.Automatical.ProcessAudio = Settings.Automatical.ProcessAudio
            Me.Automatical.ReplaceMP2 = Settings.Automatical.ReplaceMP2

            'LOG
            Me.LOG.SaveAndCloseLog = Settings.LOG.SaveAndCloseLOG
            Me.LOG.MinimizeLog = Settings.LOG.MinimizeLOG
            Me.LOG.SaveLogIn = Settings.LOG.Folder
        End Sub

        Private Sub btnAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbort.Click
            Me.Close()
        End Sub

        Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
            If Me.Output.optFolder.Checked Then
                If Not Mid(Me.Output.Folder, 2).StartsWith(":\") Then
                    Dim MessageString As String

                    MessageString = "Bei dem angegebenen Verzeichnis handelt es sich nicht" & ControlChars.NewLine & _
                                    "um einen gltigen Pfad." & ControlChars.NewLine & _
                                    ControlChars.NewLine & _
                                    "Bitte whlen Sie fr Output einen gltigen Pfad aus!"

                    Select Case MessageBox.Show(MessageString, "Achtung!", MessageBoxButtons.OKCancel, MessageBoxIcon.Information)
                        Case DialogResult.OK
                            Me.SelectNode("Output")

                            Me.Output.txtFolder.Select()
                            Exit Sub
                        Case DialogResult.Cancel
                            Me.Close()
                            Exit Sub
                    End Select
                End If
            ElseIf Me.Output.optSubFolder.Checked Then
                If Mid(Me.Output.Folder, 2).StartsWith(":\") Then
                    Dim MessageString As String

                    MessageString = "Bei der angegebenen Zeichenfolge handelt es sich um einen kompletten Pfad." & ControlChars.NewLine & _
                                    ControlChars.NewLine & _
                                    "Bitte geben Sie fr Output lediglich den Namen des Unterordners an," & ControlChars.NewLine & _
                                    "der bei jeder Verarbeitung neu angelegt werden soll!"

                    Select Case MessageBox.Show(Messagestring, "Achtung!", MessageBoxButtons.OKCancel, MessageBoxIcon.Information)
                        Case DialogResult.OK
                            Me.SelectNode("Output")

                            Me.Output.txtFolder.Select()
                            Exit Sub
                        Case DialogResult.Cancel
                            Me.Close()
                            Exit Sub
                    End Select
                End If
            End If

            If Me.Temp.Use Then
                If Not Mid(Me.Temp.Folder, 2).StartsWith(":\") Then
                    Dim MessageString As String

                    MessageString = "Bei dem angegebenen Verzeichnis handelt es sich nicht" & ControlChars.NewLine & _
                                    "um einen gltigen Pfad." & ControlChars.NewLine & _
                                    ControlChars.NewLine & _
                                    "Bitte whlen Sie fr Temp einen gltigen Pfad aus!"

                    Select Case MessageBox.Show(MessageString, "Achtung!", MessageBoxButtons.OKCancel, MessageBoxIcon.Information)
                        Case DialogResult.OK
                            Me.SelectNode("Temp")
                            Me.Temp.txtFolder.Select()
                            Exit Sub
                        Case DialogResult.Cancel
                            Me.Close()
                            Exit Sub
                    End Select

                End If
            End If

            'Werte aus dem OptionenDialog an die entsprechenden Variablen bergeben
            'Generelle Einstellungen

            'Output
            Settings.Output.Type = Me.Output.Type
            Settings.Output.Folder = Me.Output.Folder
            Settings.Output.AutoSubfolder = Me.Output.AutoSubfolder

            'Temp
            Settings.Temp.Use = Me.Temp.Use
            Settings.Temp.Folder = Me.Temp.Folder
            Settings.Temp.DeleteES = Me.Temp.DeleteES
            Settings.Temp.DeleteMPG = Me.Temp.DeleteMPG
            Settings.Temp.DeleteDVD = Me.Temp.DeleteDVD

            'DVD Einstellungen
            DATA.LanguageList.Standard = Me.DVD.StandardLanguage
            DATA.LanguageList.Original = Me.DVD.OriginalLanguage
            Settings.DVD.FilmLength = Me.DVD.FilmLength
            Settings.DVD.ChapterLength = Me.DVD.ChapterLength
            Settings.DVD.KeepDVDStructure = Me.DVD.KeepDVDStructure
            Settings.DVD.SaveEPGinOutput = Me.DVD.SaveEPGinOutput
            Settings.DVD.UseDVDauthor_0_6_10 = Me.DVD.UseDVDauthor_0_6_10

            'DVD-Men Einstellungen
            Settings.DVDMenu.Background = Me.DVDMenu.Background
            Settings.DVDMenu.BackgroundColor = Me.DVDMenu.BackgroundColor
            Settings.DVDMenu.TitleColor = Me.DVDMenu.TitleColor
            Settings.DVDMenu.ButtonColor = Me.DVDMenu.ButtonColor
            Settings.DVDMenu.HighlightColor = Me.DVDMenu.HighlightColor
            Settings.DVDMenu.SelectColor = Me.DVDMenu.SelectedColor
            Settings.DVDMenu.ShowDVDTitle = Me.DVDMenu.ShowDVDTitle
            Settings.DVDMenu.PauseAfterTitle = Me.DVDMenu.PauseAfterTitle

            'UDREC PES Streams
            Settings.Udrec.RewriteGTC = Me.Udrec.RewriteGTC
            Settings.Udrec.GenerateIDD = Me.Udrec.GenerateIDD
            Settings.Udrec.UseMinSyncCount = Me.Udrec.UseMinSyncCount
            Settings.Udrec.MinSyncCount = Me.Udrec.MinSyncCount
            Settings.Udrec.VSplit = Me.Udrec.VSplit
            Settings.Udrec.ASplit = Me.Udrec.ASplit

            'automatische Verarbeitung
            Settings.Automatical.ProcessAudio = Me.Automatical.ProcessAudio
            Settings.Automatical.ReplaceMP2 = Me.Automatical.ReplaceMP2

            'LOG
            Settings.LOG.SaveAndCloseLOG = Me.LOG.SaveAndCloseLog
            Settings.LOG.MinimizeLOG = Me.LOG.MinimizeLog
            Settings.LOG.Folder = Me.LOG.SaveLogIn

            'Eigenschaften in der INI-Datei speichern
            Settings.Functions.Write()

            Me.Close()
        End Sub
#End Region

    End Class
End Namespace