Namespace Data
    'Auflistung der Menu-Objekte
    Public Class MenuCollection
        Inherits CollectionBase

        Public Sub New(ByVal Owner As Data.Project)
            Me.owner = Owner
        End Sub

        Private owner As Data.Project

        Default Property Item(ByVal Index As Integer) As Data.Menu
            Get
                Return CType(List(Index), Data.Menu)
            End Get
            Set(ByVal Value As Data.Menu)
                List(Index) = Value
            End Set
        End Property

        Public Function Add(ByVal Menu As Data.Menu) As Integer
            Dim result As Integer
            Menu.Project = Me.owner
            result = List.Add(Menu)
            Return result
        End Function

        Public Function IndexOf(ByVal Menu As Data.Menu) As Integer
            Return List.IndexOf(Menu)
        End Function


        Public Sub Insert(ByVal Index As Integer, ByVal Menu As Data.Menu)
            List.Insert(Index, Menu)
        End Sub


        Public Sub Remove(ByVal Menu As Data.Menu)
            List.Remove(Menu)
        End Sub


        Public Function Contains(ByVal Menu As Data.Menu) As Boolean
            Return List.Contains(Menu)
        End Function


        Public Shadows Sub Clear()
            MyBase.Clear()
        End Sub
    End Class
End Namespace