Namespace Data
    'Auflistung der Movie-Objekte
    Public Class MovieCollection
        Inherits CollectionBase

        Public Sub New(ByVal Owner As Data.Project)
            Me.owner = Owner
        End Sub

        Private owner As Data.Project

        Default Property Item(ByVal Index As Integer) As Data.Movie
            Get
                Return CType(List(Index), Data.Movie)
            End Get
            Set(ByVal Value As Data.Movie)
                List(Index) = Value
            End Set
        End Property

        Public Function Add(ByVal Movie As Data.Movie) As Integer
            Dim result As Integer
            Movie.Project = Me.owner
            result = List.Add(Movie)
            Return result
        End Function

        Public Function IndexOf(ByVal Movie As Data.Movie) As Integer
            Return List.IndexOf(Movie)
        End Function


        Public Sub Insert(ByVal Index As Integer, ByVal Movie As Data.Movie)
            List.Insert(Index, Movie)
        End Sub


        Public Sub Remove(ByVal Movie As Data.Movie)
            List.Remove(Movie)
        End Sub


        Public Function Contains(ByVal Movie As Data.Movie) As Boolean
            Return List.Contains(Movie)
        End Function


        Public Shadows Sub Clear()
            MyBase.Clear()
        End Sub
    End Class
End Namespace