Public Class FolderBrowserDialog
    Inherits Windows.Forms.Design.FolderNameEditor

    Private fb As New Windows.Forms.Design.FolderNameEditor.FolderBrowser()
    Private fbReturnPath As String
    Public Description As String

    Public ReadOnly Property ReturnPath() As String
        Get
            Return fbReturnPath
        End Get
    End Property

    Public Function ShowDialog() As DialogResult
        Dim result As DialogResult
        fb.Description = Me.Description
        fb.StartLocation = FolderBrowserFolder.MyComputer
        result = fb.ShowDialog()
        If (result = DialogResult.OK) Then
            Me.fbReturnPath = fb.DirectoryPath
        Else
            Me.fbReturnPath = String.Empty
        End If
        Return result
    End Function
End Class
