Imports System.IO

Namespace OUTPUT
    Public Class LOG
        Public Shared LogDialog As UI.LogDialog
        Public Shared LOGFile As String
        Public Shared Out As StreamWriter


        Public Shared Sub WriteLine(ByVal Text As String, ByVal Icon As Images.Icon)
            If Settings.Automatical.Modus Then
                Console.WriteLine(Text)
            End If
            LogDialog.Write(Text, Icon)
        End Sub

        Public Shared Sub WriteLine(ByVal Format As String, ByVal Args() As String, ByVal Icon As Images.Icon)
            WriteLine(String.Format(Format, Args), Icon)
        End Sub

        Public Shared Sub EmptyLine()
            If Settings.Automatical.Modus Then
                Console.WriteLine()
            End If
            LogDialog.EmptyLine()
        End Sub
    End Class
End Namespace
