Imports System.IO
Namespace UI
    Public Class ChapterDialog
        Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

        Public Sub New()
            MyBase.New()

            ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
            InitializeComponent()

            ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
            Me.btnOpenList.SetImage(Images.Item(Images.Icon.Start), UI.ImageButton.Alignment.Center)
            Me.btnSaveList.SetImage(Images.Item(Images.Icon.Complete), UI.ImageButton.Alignment.Center)
            Me.btnNewPoint.SetImage(Images.Item(Images.Icon.Write), UI.ImageButton.Alignment.Center)
            Me.btnDelPoint.SetImage(Images.Item(Images.Icon.Error), UI.ImageButton.Alignment.Center)
            Me.btnDelAllPoints.SetImage(Images.Item(Images.Icon.DeleteAll), UI.ImageButton.Alignment.Center)
        End Sub

        ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        ' Fr Windows Form-Designer erforderlich
        Private components As System.ComponentModel.IContainer

        'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
        'Sie kann mit dem Windows Form-Designer modifiziert werden.
        'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
        Friend WithEvents txtChapterPoint As UI.TimeBox
        Friend WithEvents btnOpenList As UI.ImageButton
        Friend WithEvents btnSaveList As UI.ImageButton
        Friend WithEvents btnNewPoint As UI.ImageButton
        Friend WithEvents btnDelPoint As UI.ImageButton
        Friend WithEvents lsvChapters As System.Windows.Forms.ListView
        Friend WithEvents clmTime As System.Windows.Forms.ColumnHeader
        Friend WithEvents btnAbort As System.Windows.Forms.Button
        Friend WithEvents btnSave As System.Windows.Forms.Button
        Friend WithEvents QuickInfo As System.Windows.Forms.ToolTip
        Friend WithEvents btnDelAllPoints As UI.ImageButton
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.lsvChapters = New System.Windows.Forms.ListView
            Me.clmTime = New System.Windows.Forms.ColumnHeader
            Me.txtChapterPoint = New UI.TimeBox
            Me.btnOpenList = New UI.ImageButton
            Me.btnSaveList = New UI.ImageButton
            Me.btnNewPoint = New UI.ImageButton
            Me.btnDelPoint = New UI.ImageButton
            Me.btnAbort = New System.Windows.Forms.Button
            Me.btnSave = New System.Windows.Forms.Button
            Me.QuickInfo = New System.Windows.Forms.ToolTip(Me.components)
            Me.btnDelAllPoints = New UI.ImageButton
            Me.SuspendLayout()
            '
            'lsvChapters
            '
            Me.lsvChapters.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.clmTime})
            Me.lsvChapters.FullRowSelect = True
            Me.lsvChapters.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None
            Me.lsvChapters.HideSelection = False
            Me.lsvChapters.Location = New System.Drawing.Point(8, 8)
            Me.lsvChapters.MultiSelect = False
            Me.lsvChapters.Name = "lsvChapters"
            Me.lsvChapters.Size = New System.Drawing.Size(128, 160)
            Me.lsvChapters.Sorting = System.Windows.Forms.SortOrder.Ascending
            Me.lsvChapters.TabIndex = 0
            Me.lsvChapters.View = System.Windows.Forms.View.Details
            '
            'clmTime
            '
            Me.clmTime.Text = "Zeit"
            Me.clmTime.Width = 99
            '
            'txtChapterPoint
            '
            Me.txtChapterPoint.BackColor = System.Drawing.SystemColors.Window
            Me.txtChapterPoint.Enabled = False
            Me.txtChapterPoint.Location = New System.Drawing.Point(8, 176)
            Me.txtChapterPoint.Name = "txtChapterPoint"
            Me.txtChapterPoint.Size = New System.Drawing.Size(128, 20)
            Me.txtChapterPoint.TabIndex = 1
            '
            'btnOpenList
            '
            Me.btnOpenList.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnOpenList.GenerateDisabledImage = True
            Me.btnOpenList.Location = New System.Drawing.Point(140, 8)
            Me.btnOpenList.Name = "btnOpenList"
            Me.btnOpenList.Size = New System.Drawing.Size(24, 24)
            Me.btnOpenList.TabIndex = 44
            Me.btnOpenList.Tag = "OpenList"
            Me.btnOpenList.ThemedImage = Nothing
            Me.QuickInfo.SetToolTip(Me.btnOpenList, "Kapitelliste ffnen")
            '
            'btnSaveList
            '
            Me.btnSaveList.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnSaveList.GenerateDisabledImage = True
            Me.btnSaveList.Location = New System.Drawing.Point(140, 32)
            Me.btnSaveList.Name = "btnSaveList"
            Me.btnSaveList.Size = New System.Drawing.Size(24, 24)
            Me.btnSaveList.TabIndex = 45
            Me.btnSaveList.Tag = "SaveList"
            Me.btnSaveList.ThemedImage = Nothing
            Me.QuickInfo.SetToolTip(Me.btnSaveList, "Kapitelliste speichern")
            '
            'btnNewPoint
            '
            Me.btnNewPoint.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnNewPoint.GenerateDisabledImage = True
            Me.btnNewPoint.Location = New System.Drawing.Point(140, 96)
            Me.btnNewPoint.Name = "btnNewPoint"
            Me.btnNewPoint.Size = New System.Drawing.Size(24, 24)
            Me.btnNewPoint.TabIndex = 46
            Me.btnNewPoint.Tag = "NewPoint"
            Me.btnNewPoint.ThemedImage = Nothing
            Me.QuickInfo.SetToolTip(Me.btnNewPoint, "Neue Kapitelmarke hinzufgen")
            '
            'btnDelPoint
            '
            Me.btnDelPoint.Enabled = False
            Me.btnDelPoint.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnDelPoint.GenerateDisabledImage = True
            Me.btnDelPoint.Location = New System.Drawing.Point(140, 120)
            Me.btnDelPoint.Name = "btnDelPoint"
            Me.btnDelPoint.Size = New System.Drawing.Size(24, 24)
            Me.btnDelPoint.TabIndex = 47
            Me.btnDelPoint.Tag = "DelPoint"
            Me.btnDelPoint.ThemedImage = Nothing
            Me.QuickInfo.SetToolTip(Me.btnDelPoint, "Markierte Kapitelmarke lschen")
            '
            'btnAbort
            '
            Me.btnAbort.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnAbort.Location = New System.Drawing.Point(88, 208)
            Me.btnAbort.Name = "btnAbort"
            Me.btnAbort.TabIndex = 49
            Me.btnAbort.Text = "Abbrechen"
            '
            'btnSave
            '
            Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnSave.Location = New System.Drawing.Point(8, 208)
            Me.btnSave.Name = "btnSave"
            Me.btnSave.TabIndex = 48
            Me.btnSave.Text = "Speichern"
            '
            'btnDelAllPoints
            '
            Me.btnDelAllPoints.Enabled = False
            Me.btnDelAllPoints.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.btnDelAllPoints.GenerateDisabledImage = True
            Me.btnDelAllPoints.Location = New System.Drawing.Point(140, 144)
            Me.btnDelAllPoints.Name = "btnDelAllPoints"
            Me.btnDelAllPoints.Size = New System.Drawing.Size(24, 24)
            Me.btnDelAllPoints.TabIndex = 50
            Me.btnDelAllPoints.Tag = "DelAllPoints"
            Me.btnDelAllPoints.ThemedImage = Nothing
            Me.QuickInfo.SetToolTip(Me.btnDelAllPoints, "Alle Kapitelmarken lschen")
            '
            'ChapterlistDialog
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(170, 238)
            Me.Controls.Add(Me.btnDelAllPoints)
            Me.Controls.Add(Me.btnAbort)
            Me.Controls.Add(Me.btnSave)
            Me.Controls.Add(Me.btnDelPoint)
            Me.Controls.Add(Me.btnNewPoint)
            Me.Controls.Add(Me.btnSaveList)
            Me.Controls.Add(Me.btnOpenList)
            Me.Controls.Add(Me.txtChapterPoint)
            Me.Controls.Add(Me.lsvChapters)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
            Me.Name = "ChapterlistDialog"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
            Me.Text = "Kapitelliste"
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private Sub Buttons_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNewPoint.Click, btnDelPoint.Click, btnDelAllPoints.Click, btnOpenList.Click, btnSaveList.Click
            Dim Button As Button = DirectCast(sender, Button)
            Select Case Button.Tag.ToString
                Case "OpenList"
                    Dim OpenDialog As New OpenFileDialog

                    OpenDialog.Filter = "Textdatei (*.txt)|*.txt|Alle Dateien (*.*)|*.*"
                    OpenDialog.FilterIndex = 0

                    With OpenDialog
                        .Title = "Kapitelliste ffnen"
                        .RestoreDirectory = True
                        .AddExtension = True
                        .CheckFileExists = False
                        .FileName = "Kapitelliste.txt"
                    End With

                    If OpenDialog.ShowDialog() = DialogResult.OK Then
                        Me.lsvChapters.Items.Clear()
                        Dim ChapterFile As New StreamReader(OpenDialog.FileName, False)

                        Do Until chapterfile.Peek <= -1
                            Dim str As String = chapterfile.ReadLine
                            If Not str = String.Empty Then lsvChapters.Items.Add(str)
                        Loop
                        ChapterFile.Close()

                        If Not Me.lsvChapters.Items.Count = 0 Then
                            Me.lsvChapters.Items(0).Selected = True
                            Me.EnableControls = True
                        Else
                            Me.EnableControls = False
                        End If
                    End If

                Case "SaveList"
                    Dim SaveDialog As New SaveFileDialog

                    SaveDialog.Filter = "Textdatei (*.txt)|*.txt|Alle Dateien (*.*)|*.*"
                    SaveDialog.FilterIndex = 0

                    With SaveDialog
                        .Title = "Kapitelliste speichern"
                        .RestoreDirectory = True
                        .AddExtension = True
                        .CheckFileExists = False
                        .FileName = "Kapitelliste.txt"
                    End With

                    If SaveDialog.ShowDialog() = DialogResult.OK Then
                        Dim ChapterFile As New StreamWriter(SaveDialog.FileName, False)

                        For Each lsvItem As ListViewItem In Me.lsvChapters.Items
                            ChapterFile.WriteLine(lsvitem.Text)
                        Next
                        ChapterFile.Close()
                    End If

                Case "NewPoint"
                    Dim lsvItem As ListViewItem
                    Me.EnableControls = True
                    lsvItem = Me.lsvChapters.Items.Add("00:00:00.00")
                    lsvItem.Selected = True
                    Me.txtChapterPoint.Focus()

                Case "DelPoint"
                    Dim Index As Int16 = Me.lsvChapters.SelectedIndices(0) - 1
                    Me.lsvChapters.Items.Remove(Me.lsvChapters.SelectedItems(0))

                    If Me.lsvChapters.Items.Count = 0 Then
                        Me.EnableControls = False
                    Else
                        If Index < 0 Then Index = 0
                        Me.lsvChapters.Items(Index).Selected = True
                    End If

                Case "DelAllPoints"
                    Me.lsvChapters.Items.Clear()
                    Me.EnableControls = False
            End Select
        End Sub

        Private Sub lsvChapters_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lsvChapters.SelectedIndexChanged
            If Not Me.lsvChapters.SelectedItems.Count = 0 Then
                Me.txtChapterPoint.Text = Me.lsvChapters.SelectedItems(0).Text
            End If
        End Sub

        Private Sub lsvChapters_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lsvChapters.MouseUp
            If Me.lsvChapters.Items.Count = 0 Then Exit Sub
            If Me.lsvChapters.SelectedItems.Count = 0 Then Me.lsvChapters.Items(0).Selected = True

            Me.txtChapterPoint.Focus()
        End Sub

        Private Sub txtChapterPoint_Changed(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtChapterPoint.Changed
            If Me.lsvChapters.SelectedItems.Count = 0 Then Exit Sub
            Me.lsvChapters.SelectedItems(0).Text = Me.txtChapterPoint.Text
            Me.lsvChapters.Sort()
        End Sub

        Public Property ChapterDialog() As String
            Get
                If Me.lsvChapters.Items.Count = 0 Then
                    Return String.Empty
                Else
                    Dim Chapters As New System.Text.StringBuilder

                    For Each ListItem As ListViewItem In Me.lsvChapters.Items
                        Chapters.AppendFormat("{0},", ListItem.Text)
                    Next
                    Chapters.Remove(Chapters.Length - 1, 1)

                    Return Chapters.ToString
                End If
            End Get
            Set(ByVal Value As String)
                Dim Chapters() As String
                Chapters = Value.Split(",")
                For Each Chapter As String In Chapters
                    If Not Chapter = String.Empty Then Me.lsvChapters.Items.Add(Chapter)
                Next

                If Not Me.lsvChapters.Items.Count = 0 Then
                    Me.lsvChapters.Items(0).Selected = True
                    Me.EnableControls = False
                End If
            End Set
        End Property

        Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
            Me.DialogResult = DialogResult.OK
        End Sub

        Private Sub btnAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbort.Click
            Me.DialogResult = DialogResult.Cancel
        End Sub

        Private Sub lsvChapters_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lsvChapters.Click
            If Me.lsvChapters.SelectedItems.Count = 0 Then Exit Sub
            Me.txtChapterPoint.Text = Me.lsvChapters.SelectedItems(0).Text
        End Sub

        Private WriteOnly Property EnableControls() As Boolean
            Set(ByVal Value As Boolean)
                Select Case Value
                    Case True
                        Me.txtChapterPoint.Enabled = True
                        Me.btnDelPoint.Enabled = True
                        Me.btnDelAllPoints.Enabled = True
                    Case False
                        Me.txtChapterPoint.Enabled = False
                        Me.btnDelPoint.Enabled = False
                        Me.btnDelAllPoints.Enabled = False
                End Select
            End Set
        End Property
    End Class
End Namespace