Public Class ProjectViewItem
    'Public Sub New(ByVal Owner As Data.Project)
    '    Me.Owner = Owner
    'End Sub

    'Private m_owner As Data.Project
    'Public Property Owner() As Data.Project
    '    Get
    '        Return Me.m_owner
    '    End Get
    '    Set(ByVal Value As Data.Project)
    '        Me.m_owner = Value
    '    End Set
    'End Property

    'Farben zur Darstellung des Elements
    Public Sub SetBounds(ByVal Y As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal Scroll As Boolean)
        If Scroll Then
            Me.Bounds = New Rectangle(0, Y, Width - 17, Height - 1)
        Else
            Me.Bounds = New Rectangle(0, Y, Width, Height - 1)
        End If
    End Sub

    Public Const BorderSize As Integer = 1

    'Begrenzungen des Elements
    Private m_bounds As Rectangle
    Public Property Bounds() As Rectangle
        Get
            Return m_bounds
        End Get
        Set(ByVal Value As Rectangle)
            m_bounds = Value
        End Set
    End Property

    'Es wird getestet, ob sich ein MouseClick innerhalb der Grenzen des ProjectTreeNodes befindet
    Public ReadOnly Property IsMouseDown(ByVal e As MouseEventArgs) As Boolean
        Get
            If (e.X >= Bounds.X) AndAlso (e.X <= Bounds.X + Bounds.Width) AndAlso (e.Y >= Bounds.Y) AndAlso (e.Y <= Bounds.Y + Bounds.Height) Then
                Return True
            Else
                Return False
            End If
        End Get
    End Property

    'Es wird getestet, ob sich der MouseCursor innerhalb der Grenzen des ProjectTreeNodes befindet
    Public ReadOnly Property IsMouseMove(ByVal e As MouseEventArgs) As Boolean
        Get
            If (e.X >= Bounds.X) AndAlso (e.X <= Bounds.X + Bounds.Width) AndAlso (e.Y >= Bounds.Y) AndAlso (e.Y <= Bounds.Y + Bounds.Height) Then
                Return True
            Else
                Return False
            End If
        End Get
    End Property

    Public ToolTipText As String = String.Empty

    Public Function ClipText(ByVal text As String, ByVal Font As Font, ByVal g As Graphics, ByVal ToWidth As Integer) As String
        Dim tempstr As String
        If g.MeasureString(text, Font).Width <= ToWidth Then
            ToolTipText = String.Empty
            Return text
        End If

        For i As Integer = (text.Length - 1) To 0 Step -1
            tempstr = text.Substring(0, i) & "..."
            If g.MeasureString(tempstr, Font).Width <= ToWidth Then
                ToolTipText = text
                Return tempstr
            End If
        Next
    End Function
End Class
