Option Strict Off
Option Explicit On 

Namespace UI
    Public Class MPEG2Preview
        Inherits System.Windows.Forms.Form

#Region "Vom Windows Form-Designer generierter Code "
        Public Sub New()
            MyBase.New()
            'Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
            InitializeComponent()
        End Sub
        'Das Formular berschreibt den Lschvorgang, um die Komponentenliste zu bereinigen.
        Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
            If Disposing Then
                If Not components Is Nothing Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(Disposing)
        End Sub
        'Wird vom Windows Form-Designer bentigt.
        Private components As System.ComponentModel.IContainer
        Public ToolTip1 As System.Windows.Forms.ToolTip
        Public WithEvents Picture1 As System.Windows.Forms.PictureBox
        'Hinweis: Die folgende Prozedur wird vom Windows Form-Designer bentigt.
        'Das Verndern mit dem Windows Form-Designer ist nicht mglich.
        'Das Verndern mit dem Code-Editor ist nicht mglich.
        Friend WithEvents FPSTick As System.Windows.Forms.Timer
        Public WithEvents Command_NextFrame As System.Windows.Forms.Button
        Friend WithEvents VideoPosition As System.Windows.Forms.TrackBar
        Public WithEvents Command_NextTenFrames As System.Windows.Forms.Button
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
            Me.Picture1 = New System.Windows.Forms.PictureBox
            Me.VideoPosition = New System.Windows.Forms.TrackBar
            Me.FPSTick = New System.Windows.Forms.Timer(Me.components)
            Me.Command_NextFrame = New System.Windows.Forms.Button
            Me.Command_NextTenFrames = New System.Windows.Forms.Button
            CType(Me.VideoPosition, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'Picture1
            '
            Me.Picture1.BackColor = System.Drawing.SystemColors.WindowText
            Me.Picture1.Cursor = System.Windows.Forms.Cursors.Default
            Me.Picture1.ForeColor = System.Drawing.SystemColors.WindowText
            Me.Picture1.Location = New System.Drawing.Point(0, 0)
            Me.Picture1.Name = "Picture1"
            Me.Picture1.RightToLeft = System.Windows.Forms.RightToLeft.No
            Me.Picture1.Size = New System.Drawing.Size(720, 576)
            Me.Picture1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage
            Me.Picture1.TabIndex = 6
            Me.Picture1.TabStop = False
            '
            'VideoPosition
            '
            Me.VideoPosition.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.VideoPosition.LargeChange = 0
            Me.VideoPosition.Location = New System.Drawing.Point(0, 576)
            Me.VideoPosition.Maximum = 10000
            Me.VideoPosition.Name = "VideoPosition"
            Me.VideoPosition.Size = New System.Drawing.Size(723, 45)
            Me.VideoPosition.TabIndex = 1
            Me.VideoPosition.TickStyle = System.Windows.Forms.TickStyle.None
            '
            'FPSTick
            '
            '
            'Command_NextFrame
            '
            Me.Command_NextFrame.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.Command_NextFrame.BackColor = System.Drawing.SystemColors.Control
            Me.Command_NextFrame.Cursor = System.Windows.Forms.Cursors.Default
            Me.Command_NextFrame.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.Command_NextFrame.ForeColor = System.Drawing.SystemColors.ControlText
            Me.Command_NextFrame.Location = New System.Drawing.Point(335, 600)
            Me.Command_NextFrame.Name = "Command_NextFrame"
            Me.Command_NextFrame.RightToLeft = System.Windows.Forms.RightToLeft.No
            Me.Command_NextFrame.Size = New System.Drawing.Size(24, 25)
            Me.Command_NextFrame.TabIndex = 7
            Me.Command_NextFrame.Text = ">|"
            '
            'Command_NextTenFrames
            '
            Me.Command_NextTenFrames.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.Command_NextTenFrames.BackColor = System.Drawing.SystemColors.Control
            Me.Command_NextTenFrames.Cursor = System.Windows.Forms.Cursors.Default
            Me.Command_NextTenFrames.FlatStyle = System.Windows.Forms.FlatStyle.System
            Me.Command_NextTenFrames.ForeColor = System.Drawing.SystemColors.ControlText
            Me.Command_NextTenFrames.Location = New System.Drawing.Point(361, 600)
            Me.Command_NextTenFrames.Name = "Command_NextTenFrames"
            Me.Command_NextTenFrames.RightToLeft = System.Windows.Forms.RightToLeft.No
            Me.Command_NextTenFrames.Size = New System.Drawing.Size(24, 25)
            Me.Command_NextTenFrames.TabIndex = 8
            Me.Command_NextTenFrames.Text = ">>|"
            '
            'MPEG2Preview
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.BackColor = System.Drawing.SystemColors.Control
            Me.ClientSize = New System.Drawing.Size(720, 632)
            Me.Controls.Add(Me.Picture1)
            Me.Controls.Add(Me.Command_NextTenFrames)
            Me.Controls.Add(Me.Command_NextFrame)
            Me.Controls.Add(Me.VideoPosition)
            Me.Cursor = System.Windows.Forms.Cursors.Default
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow
            Me.KeyPreview = True
            Me.Location = New System.Drawing.Point(4, 23)
            Me.Name = "MPEG2Preview"
            Me.RightToLeft = System.Windows.Forms.RightToLeft.No
            Me.Text = "MPEG2Preview"
            CType(Me.VideoPosition, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub
#End Region

        Dim running As Boolean
        Dim FPS As Integer = 0
        Dim WithEvents MPEG2Decoder As MPEG2Decoder

        Public Sub SetFile(ByVal FileName As String)
            If Not MPEG2Decoder Is Nothing Then MPEG2Decoder.CloseMyMpegFile() 'just in case there is one already loaded
            Me.MPEG2Decoder = New MPEG2Decoder(FileName)
            If Not Me.MPEG2Decoder.IsInitialized Then Exit Sub

            Me.MPEG2Decoder.DecodeFrame()
            running = False
        End Sub

        Private Sub Command_GoTo_Click(ByVal sender As System.Object, ByVal eventArgs As System.EventArgs)
            Dim newfilepos As Int64

            'Ask for byteposition
            newfilepos = InputBox("New fileposition (in bytes!)?", "Set Filepointer to new position", CStr(0))

            Me.MPEG2Decoder.GoToPosition(newfilepos)
            'Show the picture at the new position
            Me.MPEG2Decoder.DecodeFrame()
        End Sub

        Private Sub Command_NextFrame_Click(ByVal sender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command_NextFrame.Click
            'mpeg2lib automatically moves to the next frame by reading
            Me.MPEG2Decoder.DecodeFrame()
        End Sub

        Private Sub Command_Play_Click(ByVal sender As System.Object, ByVal eventArgs As System.EventArgs)
            'Disable Load, GoTo, Play and Next_Frame commands

            running = True

            FPS = 0
            FPSTick.Interval = 1000
            FPSTick.Start()

            Do
                Me.MPEG2Decoder.DecodeFrame()
            Loop Until Not running

            FPSTick.Stop()
            'Reenable Load, GoTo, Play and Next_Frame commands
        End Sub

        Private Sub Command_Stop_Click(ByVal sender As System.Object, ByVal eventArgs As System.EventArgs)
            running = False
        End Sub

        Private Sub ShowForm1_Closed(ByVal sender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Closed
            running = False
            If Not Me.MPEG2Decoder Is Nothing Then Me.MPEG2Decoder.CloseMyMpegFile() 'just in case there is one loaded
        End Sub

        Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VideoPosition.Scroll
            Me.MPEG2Decoder.GoToPosition(Me.MPEG2Decoder.FileSize * (VideoPosition.Value / 10000))
            'Show the picture at the new position
            Me.MPEG2Decoder.DecodeFrame()
        End Sub

        Private Sub FPSTick_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FPSTick.Tick
            Me.Text = FPS
            FPS = 0
        End Sub

        Private Sub MPEG2Decoder_FrameChanged(ByVal sender As Object) Handles MPEG2Decoder.FrameChanged
            Me.SuspendLayout()

            Select Case Me.MPEG2Decoder.AspectRatio
                Case "4:3"
                    Me.Picture1.Height = 576
                    Me.Height = 656
                Case "16:9"
                    Me.Picture1.Height = 405
                    Me.Picture1.Location = New System.Drawing.Point(0, 0)
                    Me.Height = 485
            End Select
            VideoPosition.Value = (MPEG2Decoder.Position / MPEG2Decoder.FileSize) * 10000

            Me.Picture1.Image = Me.MPEG2Decoder.Picture
            FPS += 1
            Me.ResumeLayout()

            System.Windows.Forms.Application.DoEvents()
        End Sub

        Private Sub Command_NextTenFrames_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Command_NextTenFrames.Click
            Me.MPEG2Decoder.SkipFrames(10)
        End Sub
    End Class
End Namespace